Version 5.30:
- New Escort Jobs
  - Similar to Odd Jobs, these Escort Jobs can be accepted from a phone or the computer under Business.
  - Perform different tasks from talking and hugging, to dancing and sex.
  - Includes a few active jobs your Sim can take, go to the lot of the client and service them in person.
- Condoms can now stop WTDs from transferring (Life Improvements)
- Breast Milk, Cum, Scat, and Urine cooking recipes can now be done by all Sims, unless they dislike consumption of those things via Fetishes. (Then they won't show at all)
- Cupid's Corner can be used by Teen Sims
  - Teen Sims can create date's from Cupid's Corner.
  - Teen Sims show up under the Matches tab.
  - (Teen Sims will always show up as an option randomly, since you can't select or deselect them on the front page of Cupid's Corner)
- Added "Ask To Feel Belly" and "Ask Due Date" interactions to Sims that are inflated. Includes fun responses and buffs.
- Added descriptions to some Tags when customizing animation actors.
- Added a chance of Sims using the floor when looking for a nearby sex location to use.
- Added caching to the playlists customization dialog so it is less bothersome to use it.
- Added an interaction to Convince another Sim to ask Animal Sims for sex.
  - This can lead to them developing a preference for that animal
- Added the ability to Mentor Sims in sex to improve Sexperience skill gain.
  - Sims having sex or masturbating can be clicked on -> Mentor Sexperience
- Added the ability to Lecture on Sexperience on the Hobby whiteboard.
  - This will allow customers to gain sexperience skill at faster rates. They will also masturbate and have sex around the lot during a class to practice their skills.
  - The instructor, when not lecturing, will go around and Mentor Sims that are masturbating/having sex.
  - Sims that listen to the sexperience lecture will gain sexperience skill.
- Updated the fairy rig to properly work.
- Sims that dislike Rape will no longer be able to Rape other Sims.
- Updated the equipment menu icons to look nicer.
- Updated the icons for start sex, rough sex, rape, etc. to look nicer.
- Sims may become pregnant when drinking cum containers, from the Sim that created the cum container. (If chances of Oral pregnancy are more than Zero)

Version 5.29.2:
- Fixed issues caused by the Feb 3rd, 2026 patch

Version 5.29.1:
- Included an updated Deviant Core with a fix for all settings that specify Sim Demographics. This includes all of the autonomy settings. CURRENTLY_CONTROLLED and NON_HOUSEHOLD options now properly display at ALL times, instead of randomly sometimes.

Version 5.29:
- New Module Big Body Problems
  - Sims can have Big Cocks and Small Cocks
  - New interactions for complimenting or insulting the size of a Sims bulge
  - Sims with a Big Cock going to high school can have events happen to them.
  - Sims with a Big Cock may experience a cold sensation when using the toilet.
  - Sims can like/dislike Big Cocks and Small Cocks
  - Cock Size traits can be inherited by offspring through DNA and may manifest when the Sim becomes a Teen. Otherwise the DNA may continue to be passed to THEIR offspring.
  - Size Queen trait
    - Sims can become addicted to Big Cocks and only want Big Cocks by having sex with a number of Sims that have Big Cocks.
	- These Sims prefer Big Cocks over all other sizes and will have a really bad time if engaged in sex with Sims that do not have a Big Cock.
	- These Sims also get negative moodlets when near Sims with small or average sized cocks.
	- Size Queens can experience Big Cock withdrawals if they haven't been penetrated by a Big Cock in some time. It'll get worse if having sex with a Sim that has a small cock.
  - You can buy extra large condoms for extra large cocks.
  - Send Dick Pics to Sims to boost or hurt romantic relations.
  - Sims can lose their Anal, Oral, Vaginal virginities.
  - Horse Sims and Horse Hybrid Sims are always considered as having a Big Cock.
- Adult Social Bunny Posts
  - Adult related Social Bunny Posts, now Sims can post Sexy Messages on Social Bunny
  - Teen Sims are also unlocked to post Flirty Messages too
- Stalkers (Sexual Network)
  - Sims with low popularity and above on Sims.porn will sometimes have stalkers show up.
  - Sims will show up at places and stalk your Sim
  - Your Sim may receive creepy text messages and creepy packages/letters in the mail.
- New Aspiration (Victim Aspiration)
  - Sims can have goals to be raped by other Sims.
  - Earn the Victim trait at the end.
- Teen Sims can now play Woo Who game on the trivia box with non-teen Sims and vice verse
- Teen Sims can now do the Ask To Create Date interaction from Lovestruck with non-Teen Sims.
- Added Goat and Sheep Impregnator serums so Sims can birth both Goats and Sheep.
- Added trait inheritance for the Toilet Standing and Toilet Sitting traits.
- Added trait inheritance for Bee and Queen Bee Sims.
- Added trait inheritance for Hybrids (Hybrid Sims can now birth more hybrid Sims properly)
- Added trait inheritance for the Knotted Penis trait (It will show as Knotted Penis DNA on Sims below the age of Teen)
- The Be Attacked By Tentacle interaction can now only be triggered on Tentacle Infested lots.
- Reduced the chance of a Sim being attacked by tentacles while using the toilet on Tentacle Infested Lots.
- Rape interactions no longer decrease friendship and romance levels if the victim is into being raped. Instead it increases them.
- Rape interactions now respect the setting for no relationship changes.
- Teen Sims that go to highschool aroused now have an option to "Have Sex With a Teacher".
  - This can lower arousal, boost grade, increase fun, and increase social. However, it comes with a chance your Sim may become pregnant! (If they can be)
    - Your Sim may also fail and lose a grade if they are in a bad mood, have anti romantic traits (Such as unflirty), or have low sexperience!
  - This option is only available if your Sim is aroused when they go to school. The effects also only occur if they have sex with a teacher for most of the school day.
- Added a setting to disable ALL sex autonomy
- Teen through Elder Sims can have sex at work when aroused.
  - This can lower arousal, boost work performance, increase fun, and increase social. However, it comes with a chance your Sim may become pregnant! (If they can be).
    - Your Sim may also fail and lose work performance if they are in a bad mood, have anti romantic traits (Such as unflirty), or have low sexperience!
  - This option is only available if your Sim is aroused when they go to work. The effects also only occur if they have sex with the boss for most of the work day.
- Fixed an issue where patrons not allowed to be patrons (According to settings) were showing up to the brothel. (Such as if Male Sims were not allowed at the brothel, but they showed up anyways)
  - This fix also fixes the issue where Sims meant to be patrons would show up and quickly despawn.
- Made brothel staff a little easier to manage, they are less needy when it comes to job satisfaction.


Version 5.28:
- Added Peep Show Lot Challenge
  - This lot challenge will enable Voyeurists to appear on the lot from time to time.
- Added NPC Voyeurists
  - These NPCs will show up on the lot and peep on your Sims, they may even "get busy" in your backyard!
  - Police can be called on them if the Life Improvements Police module is installed from Life Improvements.
- Voyeur player Sims can peep on Sims taking showers, using the toilet, and bathing in bath tubs.
  - They may also peep through windows of buildings.
  - Voyeurist Player Sims can peep for secrets at Sims residences.
- Updated DD Kinky Home Invaders to work with Life Improvements Police.
- Fixed an issue that would occur when batch tagging a solo animation.
- Romantic blankets are now considered to be rugs.
- Fixed an issue that caused Sims to not become pregnant if you just wait 24 hours.
- Sims into Exhibitionism will no longer be embarrassed to be taking a shower in an Open Shower. They will also no longer be embarrassed when another Sim walks in on them taking a shower/bath.
- Added Cat Call interactions on Sims that have Cum on them, have the Cum buffs, or are topless/bottomless.
- Added integration with Life Improvements Diseases, Sims may now get diseases when engaging in sexy time.
- Bee Sims now fly around using their "wings". (Requires the Enchanted By Nature DLC)
- Mobile Vibrators
  - Sims can wear vibrators on their nipples, in their vaginas and in their anus.
  - Sims will experience vibrations every so often that increases their orgasm level.
  - Upon reaching climax, Sims will orgasm wherever they are at.
  - Lovense Support. Feel what your Sims feel.
- Aspirations
  - Aspiring Rapist - Rape Sims all you want, mind break Sims, and become a true Rapist.
  - Aspiring Zoophiliac - Romance and Sex with animals, gain a strong trait that makes it easier to befriend and romance animals.
- Sims at high arousal (i.e. Desperate For Sex) will no longer care about romance level requirements in their partner.
- Sims can now do Rape interactions on Sims they have not met (i.e. Have not done an introduction interaction on)
- Registered all the vanilla underwears for Female Sims to the selector.
- Updated included CGS, S4CL, CSF, and Deviant Core.

Version 5.27:
- Bad Neighborhood Lot Trait has now been changed to a Lot Challenge instead.
- Added Home Invasions (via Bad Neighborhood Lot Challenge)
  - Sims will randomly appear on a lot during the night and invade the house, looking for victims to Rape.
  - Your Sim can call the police to report a rapist (via the Report Rapist interaction, not the regular one)
- The Physical Health motive from Life Improvements can now be fulfilled during sex.
- The Physical Health and Mental Health motive info interactions now display during DD animations.
- Fixed jittery Sims in CAS
- Fixed floating tongue in CAS.
- Added Large Dog, Small Dog, Cat, and Fox parts to the body selector.
- When a Sim has an orgasm, their breast milk will decrease instead of increasing.
- Added Visual Selectors to each of the Body Part and Equipment Part selection dialogs.
  - These let you select CAS Parts by visual images.
  - This includes Strap-ons, Skin Overlays, Semi-Nude Parts, etc.
- Added NPC Prostitutes
  - These Sims only show up on lots with the Red Light District Lot Challenge.
  - Your Sim may request services from them, such as Handjobs, Blowjobs, Vaginal, Anal, etc.
  - NPCs on the lot may request services from the prostitutes autonomously.
- Added a setting to enable/disable autonomous porn watching.
- Hybrid parts are now selectable by Sims, such as Horns, Ears, and Tails.
- New Lot Challenge "Tentacle Infestation"
  - Sims may be attacked randomly by tentacles on lots with this Lot Challenge.
  - Tentacles may inject eggs into Sims on orgasm (With DD Milk Farm)
  - Tentacles may attack Sims using the toilet on infested lots.
  - Sims can become immune to tentacle attacks by purchasing a reward trait, wearing a hazmat suit, or by drinking a potion of tentacle immunity.
- Sims into being Raped will receive a positive buff for being raped, if
  they had a good time.
- Added interactions to quickly add the NO_PENIS_BULGE and NO_NIPPLE_BULGE cas part tags to parts of the Sim.
- Fixed issues where the sex loot actions were not using the target.
- Unlocked Clothing Optional lots for Teen Sims.
- Fixed Tentacle Infestation trait staying on Sims after they have left the tentacle infested lot.
- Added animal parts to the body selector, tails, ears, and heads, for Dogs, Cats, and Foxes.
- Sims into Raping other Sims and Evil Sims now get a positive sentiment toward their victims.
- Sims not into Raping other Sims and not Evil now get a negative sentiment toward their victims in the form of Regret.
- Sims that have raped a Sim can have the cops called on them. Police will come and attempt to arrest the rapist, sending them to prison for a time.
- Condoms can break and Birth Control can now fail.
  - Having more orgasms during sex can result in a condom having a higher chance of breaking.
  - If a Sim cums and it could result in a pregnancy. With a broken condom or failed birth control, the Sim may be scared at being pregnant.
  - Taking a pregnancy test while having pregnancy scare can result in the Sim being tense at having an accidental pregnancy.
- Fixed Scat Cakes breaking the icons of other recipes in the cooking menu.

Version 5.26.2:
- Fixed brothel patrons not properly spawning.

Version 5.26.1:
- Updated DD for version 1.116.202.1030 of The Sims 4
- Updated the included Deviant Core, Custom Gender Settings, and Sims 4 Community Library.

Version 5.26:
- Devious Desires now supports installation via Vortex, with a nice little installation menu.
- Added and integrated Quinn Sims Kneel and Submit interactions.
- Fixed an issue when bulk assigning tags, now the first actor is assumed to be the Top/Dominant/Giver and the second actor is assumed to be the Bottom/Submissive/Taker
- Fixed an issue with the Permanent Erect Penis buff not staying all the time by changing it to a trait.
- Orgasm Level is now saved between Sex acts, but decreases over time.
  - This means if a Sim is 55% orgasm level and they stop sex, when they start sex immediately after, they will be 55% (Assuming it did not decrease over time as it does.)
  - While Sims are not having sex, their orgasm level decreases slowly over time.
- Cleaned up arousal checks, so there is only one single place it is checked at.
- Harlots/Studs are now called Harlots or Studs based on their Sex instead of always being Harlot/Stud
- Brothel Workers will no longer try to watch Sims having sex or dancing.
- Moved an absolute ton of strings to the string tables for translators.
- Sims may now rape Sims who are passed out or sleeping.
  - Click on Sim -> Mean -> Malicious -> Rape -> Choose how you want your Sim to rape the other Sim.
- Sims into the Incest fetish can now crush on and be attracted to Sims that are not into Incest within Romance Reloaded. The target Sim no longer needs to be into incest also.
  - For example, Sim A is into Incest, Sim B is not. Sim A is related to Sim B. Sim A can now crush on and be attracted to Sim B, even if though Sim B isn't into Incest.
- Updated CSF, S4CL and Deviant Core.

New Occult:
- Bee Sims
  - These Bee Sims love to garden, socialize, and bee outdoors.
  - Worker Bee Sims can run into issues normal Sims tend not to, such as getting ocean water stuck in their wings or stubbing their toes.
  - Bee Sims have innate gardening abilities and autonomously take care of plants.
  - Bee Sims love to eat Honey, it is one of their favorite foods.
  - Bee Sims are more susceptible to the cold, so keep them warm!
  - DD aspects:
    - Bee Sims produce Honey instead of Breast Milk and Cum.
    - When Bee Sims ejaculate into other Sims, they may impregnate them with Eggs.
- Queen/King Bee Sims
  - They are just like Bee Sims, but they can be a bit of a snob.
  - Queen/King Bee Sims love to argue and place themselves above other Sims.
  - Queen/King Bee Sims implant more eggs into other Sims than Worker Bee Sims.
- Beecome a Bee Sim
  - You can become a Worker or Queen/King Bee Sim by either purchasing the appropriate reward trait or simply interacting with Bee Boxes (and becoming stung by them. Queen/King Bee Sims are lower chances than Worker Bee Sims)

Modding Changes:
- Species Preferences have been moved to Deviant Core.
  - **This means you need to redo your Sims species preferences!**
- Deviant Core now has a ton of new Test Set Instance tunings for testing
  - If Sims have or don't have sexual organs
  - Their sexual preferences
  - Romantic preferences
  - Whether or not Sims are enabled for Deviant Core interactions.
- DD has been updated everywhere to utilize these new test set instances, hopefully there aren't any issues with this transition.
- The speed at which Orgasm Level, Arousal Level, Breast Milk Level, and Cum Level changes can now be modified via buffs "decay_modifiers" and "continuous_statistic_modifiers"

Version 5.25.2:
- Fixed an issue where Brothel Patrons would not spawn.
- Updated the included S4CL.
- Updated the included Custom Slider Framework to version 1.20

Version 5.25.1:
- Fixed Club Activities not showing due to the patch.
- Fixed Whims/Wants not showing due to the patch.
- Updated the included Custom Slider Framework to version 1.19

Version 5.25:
- Fixed issues when loading into CAS to pick Custom Parts.
- When Sims become at least 50% aroused, their nipples will become erect through their clothing.
- Added a Penis Bulge for Sims with a Penis, it shows on all outfits, except when they are nude.
- Hybrid Sims now have ears and tails that match the hybrid type they are.

Version 5.24:
- Added the ability to undress Sims partially. i.e. Semi-Nudity
- Added the ability to attach nude and underwear parts to Sims outfits.
- Moved the sex, dirty play, etc. interactions under their own categories under Physical Intimacy to reduce clutter.
- Reworked the pregnancy and inflation code to be more reliable.
- Added DD Sim filters to Sim Snatcher to allow Slaves to engage in Animations.
- Fixed an issue where the preferred cum location was being changed when the value was set to ON_FACE, ANYWHERE, or LET_ANIMATION_DECIDE
- If Love Struck is installed, the polyamory stuff in DD is disabled in favor of the Love Struck Relationship Expectations.
- Small Chocolate Cum and Chocolate Breast Milk Containers can now be used as substitutes for recipes requiring Chocolate.
- Updated the included Deviant Core ts4script file.

Version 5.23:
- NPC Brothels now spawn a maximum of 3 Harlots/Studs, 3 Strippers, and 3 Maintenance workers.
- Added a setting to toggle autonomous animation notifications showing or not.
- Hosts will now properly use their own host station at the brothel. Instead of trying to share with their coworkers.
- Harlots/Studs and Strippers should not longer try to use the same service spots at the same time.
- Sim will now stop sitting on claimed service spots. (Unless they are the ones assigned to them)
- Incest fetish is now only checked on the Rapist Sim in Rape and not for the Victim (Since they do not get a say in it)
- Fixed an issue that caused the Use Slave interaction to not properly appear.
- Fixed issues with Pubic Hair not properly growing.
- Fixed issues with Pubic Hair not properly being shown on Sims, even when pubic hair growth is disabled.
- More Woohoo, Mess Around, and Try For Baby interactions are now properly hidden when the setting in DD to hide these vanilla interactions is enabled.
- Enabled DD interactions for the Grim Reaper.
- Fixed an issue where romance interactions would not show between Sims of different Ages (Adult to Young Adult for example)
- Added Behavior trait for Does Not Wear Strapon
  - Sims with this Behavior do not and will never wear a strap-on, during animations or otherwise.
- Added Behavior trait for Does Not Use Penis
  - Sims with this Behavior do not use their Penis during animations, including sex, masturbation, and milking. Meaning they will not be the one penetrating.
- Added potions for Vagification and Schlongification to give a vagina or penis to Sims. They can be brewed with herbalism.
- Added interactions to set a Sim to be permanently erect.
- Added new Semi-Hard Penis CAS Part. Sims that are not quite erect, but not quite flaccid, may now have a semi erect penis equipped instead. New parts need to be made available for this. (However, Horse Sims already have this support available)
- New icons for various DD interactions.
- Updated the included Deviant Core ts4script file.


Version 5.22.5:
- Updated the included mod "The More Universal Venue List" to version 1.3

Version 5.22.4:
- Fixed an issue with Pet Sim genitals not showing on Pets. (Pet Sims can no longer remove their full body outfits.)
- Included The More Universal Venue List.

Version 5.22.3:
- Updated the included S4CL version to v3.9

Version 5.22.2:
- Fixed autonomy not being able to locate a nearby location to play animations at.

Version 5.22.1:
- Fixed issues due to patch 1.110.265.1030

Version 5.22:
- Added whims for Rape (Rape Sim) and BDSM (Dominate/Submit To)
- Sims now have eggs injected into them when stung by bees, bitten by spiders, bitten by insects, or abducted by aliens, then they lay eggs after some time. (Requires Cottage Living)
- Enabled the Egg Laying fetish, now Sims can Like/Dislike Injecting eggs or Laying Eggs.
- Added cakes that can be made with feces.
- Added vagina bones to Human rig.
- The Rape Attempts Always Succeed setting is now properly used by the rape interaction.
- Fixed a scenario where the chosen location to cum at would be overridden to let the animation decide, if the setting to always show orgasm location was enabled, but the Sim was not in the list of Sims allowed to show the orgasm location on.
- When Sims do feces/urine consumption or feces/urine bathing, the appropriate overlays are now applied properly.
- Sims may accidentally lose their bottoms while running on a treadmill.
- All Sims by default now have underwear equipped, instead of all having no underwear equipped. Underwear can still be taken off by Sims, if they choose to.
- Added new behaviors:
  - Going Commando (Sims choose to not wear underwear by default)
    - Removing the Going Commando trait will automatically put underwear back on the Sim.
  - Sleeps in Nude (Sims change to Nude instead of their normal sleepwear when they go to sleep)
  - Nudist (These Sims will want to always be nude, they will constantly try to take their clothes off, if autonomous nudity is enabled.)
    - Nudist Sims do not react to other naked Nudist Sims.
	- Nudist Sims get positive buffs when naked and negative buffs when they have clothes on.
- If a Sim is wearing a skirt during a windy day, they have a chance of the wind lifting their skirt and exposing them.
  - The effect is worse if they have taken off their bottom underwear.
- Added normal interactions for unequipping Gloves, Tights, and Hats.
  - Batuu aliens can not unequip their "Hats", because that is their head.
- Fixed an issue that prevented Sims from being able to unequip gloves.
- When Sims use a Squat toilet, they now undress their bottoms properly.
- Fixed an issue where the Milk Farm and Dirty Play Whims were not properly completing.


Version 5.21.1:
- Fixed a couple issues with todays update.

Version 5.21:
- Added behaviors, a Sim could sleep in their underwear, wear loose or tight clothing, and be willing to urinate outdoors.
- Added a setting to toggle Anti Arousal.
- Added a setting to toggle DD updating physical traits in Romance Reloaded whenever Custom Slider Framework slider values change.
- Added a setting to change which Species of Sims can appear at a Brothel as Patrons.
- Added a setting to always display the Choose Preferred Cum Location dialog when a Sim has an orgasm. (Other filters still apply)
- Fixed an issue when running a playlist with Sims and another Sim joins, where DD does not properly recognize that the playlist is no longer valid for the number of Sims.
- When Sims breastfeed, they no longer put on their top when child Sims are around.
- Added a Whim to Have Sex with another Sim. (It cannot be fulfilled via Start Sexy Time)
- Added whims for masturbating, watching porn, breast milking, penis milking, breast milk consumption, and cum consumption.
- Added whims for defecating on furniture, defecating on Sims, defecating in front of Sims, being defecated on, and watching a Sim defecate
- Added whims for urinating on furniture, urinating on Sims, urinating in front of Sims, being urinated on, and watching a Sim urinate.
- Added a positive buff when a Sim gets a lap dance and when a Sim gives a lap dance.
- Fixed an issue where start sexy time was showing Dancer and Non Dancer in reverse order for lap dancing and pole dancing
- The Breast Milk Swelling High and Medium buffs are now uncomfortable mood instead of Fine.
- Added Sexually Satisfied happy buff when Sims have low arousal. (Meaning their needs are being met)
- The Desperate for Sex and Needs Sex buffs are now tense instead of Fine.
- Updated the likes dislikes so fetishes have their own category.
- Removed package "DDlikesdislikes_cascategories.package" and added "Nutty-TheOtherCustomPreferencesMod.package" (In DDRequirements)
- Watch Porn interactions are now locked when a Computer is locked for a Sim.
- Maybe fixed an issue where Sims would apply overlays to other Sims in random places.
- Fixed an issue when looking for objects for Human Sims to do their business.
- Updated the included S4CL and CGS

Version 5.20.4:
- Fixed an issue with the romance track of Pet Sims to Human Sims.
- Fixed an issue where Pet Sims did not have access to the attracted to Male/Female traits or the Sexual Orientation traits for woohoo.
- Fixed an issue when getting the duration for brothel staff where the value was not being checked as a float, so it was not being converted to a timespan
  - TLDR: Fixed another error that would occur when opening brothels.

Version 5.20.3:
- Fixed issues where fetishe Likes/Dislikes caused infinite loading into CAS.

Version 5.20.2:
- Fixed an error that occurs when opening the brothel.
- Fixed an issue when a player patron requests service from a player harlot/stud

Version 5.20.1:
- Fixed an error caused by the Sims 4 patch of 07/23/2024

Version 5.20:
- Added interactions to the computer for Sims to look at porn and learn new fetishes.
- Added autonomous mobile milking when Sims reach 50% fullness.
- Fixed an issue in animations when Sims are wearing a full body outfit, where on animation change, the Sim would put their outfit back on.
- Fixed an issue where Batuu aliens could have their "heads" removed during animations or via interactions.
- Excluded Hondo entirely from nudity, since removing anything off his body also removes his "head".
- Added the ability to remove Hats.
- Fixed an issue with no unequip not being looked at when unequipping body parts.
- When a Sim is erect, the erection underwear chosen is now more consistent and won't be changing a million times a second.
- Chosen condoms and pubic hair on Sims will be more consistent.
- Fixed an issue where Player Brothel Patrons would not properly end their service when no animations were found to play.
- Readded the Fight and R* interactions.
- Unlocked all wedding interactions, Propose, Ask On Date, and woohoo interactions for Teen Sims.
- Added a proper test for incest to the Physical Intimacy interactions. Autonomy can only happen if a Sim likes incest. The player can choose to do it with Sims that do not dislike incest.
- Fixed an argument issue when coming out of CAS for mannequins.
- Added interactions to the computer for Sims to look at porn and learn new fetishes.
- Renamed Sexual Media/Sexual Network to Sims.porn to fit more with the new way to learn fetishes.
- Added cakes that can be made with Breast Milk or Cum.
- Updated the included Deviant Core and S4CL.

Version 5.19:
- Moved deviousdesires_hotkeys.ts4script into DDModules.
- Organized the scripts for DD Hotkeys a bit better inside deviousdesires_hotkeys.ts4script
- Created deviousdesires_hotkeys.package
- Vampires that have the perk for turning other Sims into vampires, will turn other Sims into vampires if they are thirsty during rape.
- Werewolves that have the perk for turning other Sims into werewolves, will turn other Sims into werewolves when rampaging and raping.
- Cleaned up and maybe fixed the code when applying the traumatized buff.
- Cleaned up and maybe fixed the code when applying the Conflicted Emotions buff.
- Fixed an issue where the Bulge traits from Romance Reloaded would apply to Sims without a Penis.
- Fixed an issue with autonomous rape.
- Added an interaction to choose a bunch of Sims and Sim demographics to apply a fetish template to.
- DD Dirty Play: 
  - Sims will no longer autonomously do the "Grab Serving" and "Consume" interactions on Feces Piles and Pee Puddles that are outside.
- Added Hybrid traits.
  - These traits indicate a Sim is a hybrid of an Animal or Human. These traits are used in pregnancies to determine the species of their offsprings.
    - Currently works for Large Dog, Small Dog, Cat, Fox, Horse, Cow, Chicken, Llama, Sheep, Goat.
  - If a Hybrid Sim becomes pregnant, there is a chance they may produce offspring that match any of their Hybrid traits.
    - If a Human Sim is a Hybrid Cat and Hybrid Large Dog, they have a chance to produce a Cat or Large Dog instead of their normal offspring. (Even if the other parent is also a Human Sim)
	- The same applies to Animal Sims. They may produce Sims that have a species for any of their Hybrid traits, regardless of the species of their partner.
    - Offspring species chances will increase the more Hybrid traits involved.
	  - All Hybrid traits are taken into account when deciding the species of an offspring.
      - Example: If Sim A is Hybrid Cat and Sim B is Hybrid Cat, then it will be more likely that a Cat will be born from the pregnancy.
      - Example: If Sim A is a Hybrid Cat AND a Cat, and Sim B is a Large Dog AND a Hybrid Cat, then it will be three times as likely for the offspring to become a Cat than for it to become a Large Dog (1/4 chance of Large Dog and 3/4 chance of Cat)
  - Hybrid traits can also automatically be passed down to the offspring. They are inheritable. (They only begin having any use when a Sim becomes a Teen or Older, obviously)
  - The Hybrid traits for Animal Objects, such as Cows, Chickens, Llamas, Sheep, and Goats, only make a difference at the time of birth where the offspring will instead be replaced with an animal object and placed in the inventory of the pregnant Sim.
    - Animal Objects do not inherit Hybrid traits, because they do not have Genes that can be passed down.
- Changed how the Animal pregnancy serums function. They are no longer 100% effective, closer to 80%. However, if a Sim is born, they will inherit a Hybrid trait relating to the serum that was drank.
  - Example: If a Sim is born while the Impregnator Fowl is on the pregnant Sim, then the Baby will get a Hybrid Chicken trait and could potentially produce Chickens in the future (When they become Teen or Older and become pregnant or cause another Sim to become pregnant at that time)
- Brothels:
  - Large Dog, Small Dog, Cat, Fox, and Horse Sims can visit Brothels as Harlot/Stud patrons.
  - Large Dog, Small Dog, Cat, Fox, and Horse Sims can work at Brothels as Harlots/Studs.
  - When a Harlot/Stud is going to service their Patrons, if no animations are found, then the "animation" portion will be skipped and the patron will simply pay out as if they played an animation.
  - Unlocked Harlot/Stud Service locations, Patrons can now be assigned to objects other than a Double Bed.
  - Added a way to specify whether a service spot is available for Stripper Patrons, Harlot/Stud Patrons, or both.
  - Brothel Employees can now be designated to work in the mornings (8 am to 8 pm) or in the evenings (8 pm to 8 am) or All Day as it has been.
    - Employees will work an All Day shift by default.
  - Player Sims working at Brothels now have reasonable working hours and days off, like the other careers.
  - Unlocked Pregnancies in Brothels.
  - Added an interaction to purchase contraceptives for Employees in brothels.
  - Fixed an issue when designing brothel uniforms for Player Sims.
  - Reduced the amount of money Harlots/Studs and Strippers make by about 80%
  - Brothel Patrons may order additional Harlots/Studs for service. Meaning, there could be multiple Harlots and Studs working a group of patrons.
  - Fixed a problem where custom careers were being removed from Sims when loading back in. This was affecting Brothel Careers, Prostitution, and Escort careers.
  - This also fixes an issue where brothel employees are rehired everytime you load in to your brothel.
- CAS Part Customizations:
  - Expanded the Customize CAS Parts dialog under DD Settings -> Customize CAS Parts
  - You can now customize the tags of CAS Parts both existing in DD and CAS Parts on a Sim directly.
  - Pubic Hair now shows when Sims put on CAS Parts that are also tagged as PUBIC_HAIR_ABOVE_GROIN, PUBIC_HAIR_TESTICLES, or PUBIC_HAIR_VAGINA
    - For example, if a Sim has underwear that is lower than normal, but pubic hair SHOULD be visible with the CAS Part. DD will automatically show the Pubic Hair on the Sim.
  - Skin Overlays show when Sims put on CAS Parts that are also tagged as HAS_VISIBLE_PENIS
    - For example, if a Sim has underwear that includes an erect penis of some kind, or their penis is sticking out of the underwear in some way. DD will automatically put on any selected Skin Overlays of the Sim.
- DD Nudity reactions no longer apply to Sims when they are
  - Skinny dipping
  - In a hotspring, steam room, or hot tub while nude
  - Swimming,
  - On a lot that is clothing optional
  - Under the effects of the Blooming Nudity painting (From DD).
- When putting on underwear while wearing normal clothes, if a Sim is not currently wearing underwear, that part of their body will instead become nude.
- When putting on underwear while nude, if a Sim is not currently wearing underwear, that part of their body will instead become their normal clothes.
- DD will now override the "Can use toilet standing" and "Can use toilet sitting" text in Custom Gender Settings while DD is installed. They now say "Has Penis" and "Has Vagina"
- Updated the included S4CL to v3.4 and the included DC to v1.14
- Included Custom Gender Settings v1.15 in DDRequirements

Version 5.18:
- Devious Desires now has hotkeys, check the readme for a list of them!
- Added a command to reset customized positioning of Sims in animations. "dd.reset_anim_positions"
- Added Scat overlays to DD Dirty Play.
- Added a setting to toggle scaling the height of Sims during animations.
- Fixed an issue when starting pregnancies between incestous Sims.
- Fixed a bug that allowed NPC Sims to get inactive/unimplemented fetishes assigned to them.
- Sims that are not enabled for DD now produce "anti arousal" vibes, causing Sims around them to drop in arousal.
  - For example, child Sims will produce this vibe, causing Sims around Child Sims to drop in arousal over time. This includes Child Sims, Infant Sims, Toddler Sims, Kittens, and Puppies. Basically all Sims not enabled for DD.
- The notification for whether a Sim is pregnant or not will now show regardless of whether they are actually pregnant. (To keep it a surprise)
- Lactation in pregnant Sims will now occur when they reach trimester 2, instead of when they become pregnant.
- Added integration with Romance Reloaded and enabled Pet Sims for RR while DD Pets is installed.
- The movement hotkeys now properly update and store the changed position of Sims.
- Woohoo Partners rel bit is now accounted for when Sims attempt to start sex.
- Added an "Ask To Be Woohoo Partners" interaction for Sims that are blood relatives. (And have a fetish for incest)
- Updated Body Enhancements to use the body size traits from Romance Reloaded.
- Added No, Low, and High Libido reward traits for Sims to have altered Arousal gain rates (Or no arousal gain in the case of No Libido)
- Attraction now changes the amount of arousal change when Sims view a nude/partially nude Sim
- Nudity reactions now change arousal based on whether a Sim finds the naked Sim attractive or not.
- Sims will auto apply contraceptives to themselves and any other involved Sims during sex. (If they have contraceptives in their inventory)
- When Sims take a Brisk or Cold Shower or Bath (Or a Bath with Soaks "Muscle Release Soak"), their arousal will now drop a little.
- When Sims take a Steamy Shower or a Bath with Soaks (Rose Petal, Lavender, Milk Honey, and Citrus), their arousal will now raise a little.
- Added Animation Playlists to Start Sexy Time.
  - These playlists can also be created when doing SHIFT+CLICK on things -> DD -> Customize Playlists.
  - The sexual organs/location/actors of the playlist are determined by the first animation in the playlist. (Reordering will update the playlist information
- Moved all scripts related to DD Brothels into a separate ts4script file under DDModules "deviousdesires_brothel.ts4script". Also updated a small thing in the Prostitution Package.
- Moved all scripts related to DD Milk Farm into a separate ts4script file under DDModules "deviousdesires_milk_farm.ts4script".
- Moved all scripts related to DD Dirty Play into a separate ts4script file under DDModules "deviousdesires_dirty_play.ts4script".
- Moved all scripts related to DD Kinky into a separate ts4script file under DDModules "deviousdesires_kinky.ts4script".
- Moved all scripts related to DD Anthros into a separate ts4script file under DDModules "deviousdesires_anthros.ts4script".
- Moved all scripts related to DD Pet Play into a separate ts4script file under DDModules "deviousdesires_pet_play.ts4script".
- Added an interaction to oral pill containers and condom containers to unpack all pills/condoms from them.
- Added a way to exempt Sims from Devious Desires interactions. SHIFT+CLICK on Sim -> DD -> Traits -> Add -> DD Exempt
- Added debug interactions to set milk and inflation levels
- The Rape Attempts always succeed setting now works for the rape interaction.
- DD Sex will now complete Woohoo With wants Sims can get.
- Added minor integration with Lumpinou LGBTQ mod to prevent it breaking DD Pet romance interactions.
- The Rape interactions now have a cooldown between Sims doing the interaction.
- Fixed an issue where animation playlists missing animations would be able to load and would cause errors.
- Fixed an issue where animation playlists could potentially be loaded before animations were loaded.
- Fixed an issue with the Reversus Mind Breakus spell tome not actually teaching that spell, it also had an incorrect description.
- Buffs such as Creampied, Pearl Necklace, and Cum Yums are now applied regardless of whether overlays are enabled or not, since they aren't visual.
- Fixed an issue where the Creampied, Pearl Necklace, and Cum Yums buffs would not be applied if a custom location was specified for the cum location.

Version 5.17.2:
- Updated the included Deviant Core to 1.12

Version 5.17.1:
- Fixed a mismatching function within the Occult Equipment buff.

Version 5.17:
- Fixed an error with body enhancement buffs.


Version 5.16:
- Fixed an issue when scaling the height of Sims during animations.
- The Door Lock/Unlock interactions can now be used during animations.
- The camera interaction from the ISO Love Photos mod can now be used during animations.
- Updated DD for version 1.105.297.1030 of Sims 4
- Updated the included S4Cl to version v3.2
- Updated the included DC to version v1.11

Version 5.15:
- DD Base
  - Added the Lusty Secrets Shop where you can purchase various DD related items. Located on Computers and the Phone.
  - Sexual Orientation
    - Changed the Dog, Fox, Cat, and Horse fetishes into gender option
      Sexual Orientation Species preferences. These species preferences also
      now tie in with flirt and sex interactions, just as all other sexual
      orientation options do.
    - Species Preferences can be updated/changed using Custom Gender Settings under Sexual Orientation.
    - Sims exploring their sexuality will now be allowed to do all
      romance/sex interactions regardless of their Sexual Orientations,
      because they are exploring. (Change them to not exploring to "set in
      stone" their sexual orientation)
- DD Kinky
  - Remade and combined the Rape interactions into a single Rape interaction under Mean -> Malicious
- New module "Sexual Network"
  - Setup a Sexual Network profile and earn followers. (Available to Sims at level 5 Sexperience and above)
    - Record Adult Videos at a Video Station. (Do the normal recordings, topless, bottomless, or nude to make them adult)
      - These videos can be uploaded to earn Sexual Network followers.
    - Added the ability to take topless, bottomless, and even nude selfies from the phone.
      - These pics can be uploaded to the Sexual Network to earn followers.
      - Streaming drone, snowboarding videos, and paintings can all be classified as Adult
    - Breast Milk, Cum, Feces, and Urine can be sold on the sexual network. The price increases with number of followers. (Starting at 1000 followers)
- DD Prostitution
  - New gig career "Escort" (Part of DD Prostitution)
    - This career requires the Dream Home Decorator DLC.
    - You can accept Gigs that involve Sex or Lap Dancing to earn money.
    - Match the Clients Likes, avoid their Dislikes, and you'll gain reputation, fame, and career performance!
  - Added a notification after seducing a client for prostitutes.
- Brothel
  - Added the ability to open a brothel, even if you don't own it. (From the phone)
- Updates
  - Updated the DDBodyOverlays.package, it now comes in three weights, a light, medium, and heavy variant. These are applied during inflation.
  - Included a package containing Pubic Hairs in the Download.
- Fixes
  - Show Available Animations interaction now shows on all objects, even those without animations. This way animators can see the UID of objects.
  - Fixed an issue when trying to clock in as active at a brothel.
  - Fixed an issue where Child Sims were incorrectly reacting to (and getting Embarrassed from) Animal Sims when the Animal Sims had nude parts equipped (Because they always have nude parts equipped)
  - Fixed a calculation issue with scaling of breasts, belly, and testicles. They should now swell properly starting at the smallest being whatever size the Sim has originally.


Version 5.14:
- Added nudity reactions when a Sim is nude (via DD)
- Sims will gain arousal from being around naked Sims (even partially naked Sims), if their sexual preferences are a match for the Sim that is naked.
  - When a Sim does not "like what they see", their arousal will drop instead.
  - Sims will gain arousal from seeing Sims in their underwear as well but about half as much.
- Sims will automatically put their clothes back on when in the presence of Sims below the age of Teen. To avoid the embarrassment.
- Combined all the modules into the main DD download.
- When Sims get inflated, a belly overlay is now applied to them so as to hide Abs.
- Fixed an issue where Sims that had both a Penis and preferred giving, would have an increased orgasm rate.
- Updated Human and Anthro rigs to include tongue bones.
- If a Sim has an orgasm while performing a Tentacle animation, they will become "inflated" by the tentacles.
- Sims will now have to "Put on" their underwear if they want them to show.
- Werewolves no longer equip a tongue, at least not until that can be sorted out.
- Normal Sex no longer excludes doggy style, missionary, cowgirl, reverse cowgirl, or mating press as initial animations.
- Added a setting to toggle sweat being applied.
- Added a debug interaction to force a Sim that stole clothes to give them back to your Sim.
- When a Sim has an orgasm, they will only apply overlays if they actually produce Cum.
- When checking SS slavery and for a Slave to be on their master owned lot, it now actually checks if the lot is master owned.
- Removed Fetish enjoyment level values in favor of entirely using the LIKE and DISLIKE traits.
- Fixed issues where the DanceGather role state from Pet Weddings was sometimes overriding the role states of entirely unrelated Situations, causing funky behavior.

Version 5.13:
- Pubic Hair will now grow over time.
  - If you choose a Heavy Hair, it'll automatically select a Medium and Light hair to go with it. It won't grow past Heavy. None -> Light -> Medium -> Heavy
  - If you choose a Medium Hair, it'll automatically select a Light hair to go with it. It won't grow past medium. None -> Light -> Medium
  - If you choose a Light Hair, it won't grow past light. None -> Light
  - Basically, the Heaviest hair you'll see on the Sim is the one you'll see in the icon of the Pubic Hair.
  - Sim will start with no pubic hair, over time, it'll grow to Light, then Medium, then Heavy.
  - Pubic Hair may also be shaved in the Shower when the Sim has Light or above.
- Fixed an issue where Equipment -> Nude -> All would unequip body hair, tattoos, and scars.

Version 5.12:
- Added a new sign that will allow making all Sims naked while inside on a lot. (Called "Blooming Nudity" DD Wall Painting)
  - Once placed, click on it and choose Disallow Clothing While Indoors.
- Enabled Horse Sims to choose Genital Body Parts
- Added interactions for Horse Sims to perform Sexual actions, such as Sex, DD Kinky interactions, DD Dirty Play interactions, etc. (Though no animations yet)
- Fixed issues (Hopefully permanently) where Animal Sims were not putting on their genitals.
- Added notifications when registering/retiring as a prostitute.
- Added an interaction to be able to do seduction with a client when no animations are available for prostitution
- The seduction interaction will no longer add the sexperience buffs

Version 5.11:
- Readded interactions Flirt, Ask To Move In, Woohoo In Steam Room, Try For Baby In Steam Room, and Try For Baby In Photobooth to Teen Sims
- Fixed an issue where upon being born, Hybrid children were not having the correct relationship bit with their Father/Mother
- Cleaned up the hybrid pets code quite a bit. Pulled many things out into utilities and created a new pregnancy tracker event (that will be moved to S4CL eventually)
- Hybrid Sims birthed from Dog/Fox Sim x Human Sim will have a chance of becoming a werewolf
- Hybrid Sims birthed from Cat x Human Sims can potentially result in either a Witch or Vampire Sim being born.
- Sims impregnated by dolphins will now give birth to mermaid Sims (A Sim is considered to be "impregnated by dolphin" if the Sim has an orgasm while performing an animation involving a Dolphin prop, i.e. has the Dolphin tag)
- When a Sim has an orgasm in an animation involving an object animal, the Sim will become pregnant from that animal. For example, if a Sim is "masturbating" in an animation tagged for Cow, if the Sim has an orgasm, they will become pregnant, once the Sim gives birth, they will then have a new Cow in their inventory.
  - Cows come out as Adult Cows, since there is no Calf available.
  - Chickens will come out as Chicks.
- Created "deviousdesires_pets.ts4script" file.
  - Moved most, if not all of the code related to DD Pets to the "deviousdesires_pets.ts4script" file.
- Added DD Pet Weddings
  - Human Sims can now ask to be the girlfriend/boyfriend of their Pet Sims
  - Human Sims can now also propose to their Pet Sims, essentially becoming engaged with them.
  - Human Sims can now have a Wedding to officially marry their Pet Sims.
  - (Without Wedding Stories DLC) They can plan a wedding event on a wedding Arch. Choose the "Plan Wedding Event (Human To Animal)" interaction.
  - (With Wedding Stories DLC) They can do various Wedding activities, such as the following:
    - Vows
	- Toast Making
	- Speeches
	- Walking Down Aisles
	- Spousal Kisses
	- Tea Drinking
	- Cutting Of The Cake (On the cake, choose the one that shows HtA)
	- Dancing
	- Rice Throwing
	- Wedding Feast
	- Bubble Blowing
  - To start planning, choose "Plan Wedding Event (Human To Animal)" from the phone under Social.
  - Romance Changes
    - Instead of custom relationship bits, Human Sims x Pet Sims now uses the vanilla romance Relationship Bits. This causes a problem however in that the Human Sims with existing romantic relationships with Pet Sims won't be properly updated with the relationship bits.
      - To fix this, use a mod like Control Menu #control-menu to set their romantic relationship to zero, then back to what it originally was.

Version 5.10.1:
- Fixed errors caused by the Horse DLC update.
- Fixed a vanilla issue where Teen Sims were unable to gain romance with Young Adult, Adult, and Elder Sims.
- Devious Desires now requires at least version 2.8 of Sims 4 Community Library
- Devious Desires now requires at least version 1.8 of Deviant Core
- Fixed an error when trying to turn an already existing business into a Brothel, where the business type was not Brothel.

Version 5.10:
- Fixed an issue with the Choose Cum Location dialog not appearing when it should.
- Fixed an issue when clicking on objects where the Sim selection shows up behind the "No Animations Found" dialog, making it confusing.
- Devious Desires now requires at least version 2.7 of S4CL.
- DD Milk Farm now utilizes all of the new breast sliders from CSF

Version 5.9:
- Unlocked the pregnancy buffs and sliders for Teen Sims
- If a Sim has conflicted emotions and has at least 3 orgasms, the conflicted emotions buff timer will be reset.
- Mind broken Sims require a different amount of orgasms in order to have a positive experience in rape (Instead of 5):
  - 4 if the Sim is lightly mind broken 
  - 3 if the Sim is moderately mind broken
  - 2 if the Sim is severely mind broken
- Utilize the new Actor Preferences setting when querying for Special Tagged animations introduced in Deviant Core 1.7
- Devious Desires now requires at least version 1.7 of Deviant Core.
- Removed the accidental Sim Snatcher requirement for Coerce Into Sex interaction (Sim Snatcher no longer required, my bad!)
- Fixed the name of the Reversus Mind Breakus spell tome
- If a Sim has conflicted emotions and has at least 3 orgasms, the conflicted emotions buff timer will be reset.
- Mind broken Sims require a different amount of orgasms in order to have a positive experience in rape (Instead of 5):
  - 4 if the Sim is lightly mind broken 
  - 3 if the Sim is moderately mind broken
  - 2 if the Sim is severely mind broken

Version 5.8:
- Added the ability to choose body slots that a Sim will never unequip (through DD, vanilla is unaffected)
- Fixed some issues with the Start Sexy Time dialog where an error would be thrown for the options not yet setup fully.
- Added operations for Humiliation and Seduction to the animation customization dialog
- Devious Desires now requires at least version 1.6 of Deviant Core.
- Added Mind Breakage
  - To start mind breaking a Sim, simply Rape them until they have a positive experience in Rape.
  - Once this happens, the Sim can be mind broken further by having sex with them.
  - At moderate mind breakage, the Sim will gain Arousal at twice the normal rate.
  - At severe mind breakage, the Sim will accept any Fetish.
  - Mind Breakage can be reversed using the new Reversus Mind Breakus spell (Learn from a bought tome)
- Breast Milk can now be used as a replacement for normal milk when cooking.
- Sims with Conflicted Emotions will ignore requirements for domination. Sims will be able to dominate them regardless of their fetishes and romance.
- The Sim that caused Conflicted Emotions with another Sim should be allowed to dominate the Sim. Sims that did not cause the Conflicted Emotions, will not be allowed to dominate the Sim.
- A moderately mind broken Sim can be humiliated. Humiliation will increase mind breakage
- Coerce a Sim into Sex (This will lose friendship). Once Coerced, the Sim will be forced to accept any fetish interactions your Sim is into. Coercion lasts for one sex action or if the Sim leaves the lot.
- Added an interaction to humiliate Sims with Conflicted Emotions.

Version 5.7:
- Moved even more of the interactions to proper categories on the interaction wheel.
- Added the ability for Sims to self impregnate. Meaning they become pregnant by having an orgasm inside themselves.
- Fixed some issues with missing interaction names on pirate day
- Added a check to prevent a Sim from doing seduction interactions when they already know the romantic orientation of other Sims.
- Prevented the Milking interactions from appearing on Sims they shouldn't, such as Penis Milking interactions on Sims without a Penis.
- Added the ability for Sims to create a Serum (requires they have learned at least the Age Away serum first!). This Serum will cause the next pregnancy a Sim has to result in the Cottage Living Farm animals, such as Chickens, Cows, and Llamas.

Version 5.6:
- Added spells and Spell Tomes for temporarily giving Sims a Penis or a Vagina.
- When a Sim does the vanilla Breastfeeding, their top will be unequipped, unless they are wearing a full body outfit. Their top will be put back on when they put the baby/infant down.
- When a Sim gets a massage, they will completely undress.
- Moved many interactions to the new categories.
- When a Sim begins breastfeeding, they will lose a portion of milk equivalent to a single bottle.
- Added an orgasm component to Cum Consumption to enable inflation
- When Sims have an orgasm while breast or penis milking, they will produce an extra bottle.
- When Sims have an orgasm while breast milk or cum consumption, they will have their milk/cum level replenished by an amount equal to a bottle.

Version 5.5:
- Fixed issues with Sims not properly giving birth.
- Fixed an error that would occur when Sims change their clothing near a hamper.
- Fixed an error that was causing issues with Sims picking items up.
- Devious Desires now requires at least version 2.5 of S4CL

Version 5.4:
- Fixed an issue with Strap-ons not being properly equipped in some cases.
- Fixed an issue with overlays being removed when they should not be.
- When Sims ride a bike or swim in a pool/ocean, they have a chance of losing their bottoms
- Added an interaction to dressers to be able to change underwear.
- Added the ability to steal clothing from Hampers from the household members who live there. The next time the Sim changes their outfit, they'll find their clothes to be missing.
  - Can also give the clothes back to the Sim the clothes were stolen from.
- If wearing a full body outfit when Sims start an animation that requires only the top to be removed, only the top will be removed with the bottom becoming underwear and vice verse if the only the bottoms are to be removed by the animations.
- Improved the performance of Sims changing their outfits at the start of animations.
- Added piercings and pasties as selections in the equipment selector.
  - Accessory boxes can be bought from the gift store.
- Added a buff that applies drooling overlays when a Sim has a mouth full of Cum.
- The Cum overlay buffs such as Pearl Necklace, Creampie, etc. now wash off with the normal overlays.
- Added sweat overlays when Sims reach certain thresholds of orgasm. Light, Heavy, and a VFX. https://xldsims.tumblr.com/post/139654327414/a-shiny-ish-oiled-up-skin-finish-that-wont-blind
- Devious Desires now requires at least version 1.5 of Deviant Core.
- Added the DD Prostitution Module
  - Added lessons for DD Prostitution to the ingame lessons.
- Fixed an issue with supplements not costing simoleons
- Pet Sims no longer increase in arousal if they are Fixed or Can't Reproduce.
- The swelling of Sims breasts and testicles now scales differently depending on the level of Skill the Sim has in the production skills.
- Prevented the Romance interactions from being available for Sims that don't have a fetish for Pets.
- Piercings increase breast milk and cum production.
- Updated Breast sliders to use the new ones from v1.16 of CSF

Version 5.3:
- Updated the Info interactions to use the new Info pie menu from S4CL
- Added a new interaction to Kiss another Sim but using a dynamic animation.
- Moved many of the pregnancy debug strings to the string tables
- Fixed the orgasm fill rate setting description, it no longer states that it is in real time.
- When Sims do their business while sitting on a toilet, they will no undress their bottoms.
- Added new buffs when Sims get Cum on or in them, Vaginal, Anal, and on their Chest.
- Fixed an issue with Unequip Types not being properly put on Animations via Animation Customizations.
- The sexperience sentiment buffs now last 15 Sim Minutes instead of 3 Sim Hours
- Changed DD to use the Romantic Sexual Orientation from vanilla instead of the Woohoo Sexual Orientation for DD animations (Since the Woohoo one is hardly used anywhere currently)
- Updated the Watch interactions, it can no longer happen through walls and also properly checks if a Sim is into it or not.
- Possibly fixed the strapons having a shine to them.
- DD now requires at least version 2.3 of Sims 4 Community Library
- DD now requires at least version 1.3 of Deviant Core
- Milk/Cum Flavors are now no longer randomized.
- The flavors of milk your Sim produces is based on what they eat, if they eat Chocolate, they will produce Chocolate flavored milk/cum, if they eat food containing Bananas, they will produce Banana flavored milk/cum, etc.
  - Breast Milk Flavors: Chocolate, Strawberry, Banana
  - Cum Flavors: Chocolate, Strawberry, Banana, Grape
- Sims will build up a level of "storage" for various flavors and when milk of that flavor is produced, their storage level will gradually decrease.
- Added interactions to manually deflate Sims on a toilet when they are inflated.
  - Sims will autonomously deflate themselves
  - There is a delay before a Sim deflates themselves if they are neutral to or like being inflated.
- Removed the maximum inflation settings, inflation is now completely between zero and 100 percent.
- Removed the max total vagina inflation and max total stomach inflation settings
- Fixed the Urine Consumption Like having the wrong description
- Reduced the amount of Hunger and Bladder gained when doing Breastfeeding, Cum Consumption, Feces Consumption, and Urine Consumption interactions.
- Reduced the amount of Cum and Breast Milk lost when doing Breastfeeding and Cum Consumption interactions.
- If an Actor is tagged as NON_PARTICIPANT, their Hunger, Bladder, Cum, and Breast Milk will remain unchanged in their respective animatin usages.
- Added buffs that apply after consuming Breast Milk and Cum from containers and from Breastfeeding and Cum Consumption animations.
- Certain animation tags will increase Breast Milk and Cum production.
- The Creampie buff increases Breast Milk Production while the Creampie Anal buff increases Cum Production
- Reduced the amount of Urine Containers produced when urinating on the ground
- Increased the amount of bladder gained when a Sim is urinating on objects and when they are defecating on objects.

Version 5.2:
- Added a None option to Skin Overlay selection so you may choose to have no Skin Overlay on your Sim. (In case the available Skin Overlays cause issues or something)
- Added a permission flag to all AnimationPermissions to indicate which Sim initiated an animation.
- Changed the amount of time that must pass before a Sim loses milking skill from 36 Sim hours to 72 Sim hours
- Added the ability to tell a Sim they can have sex/romance with specific other Sims.
- The ability to tell a Sim this is locked behind a committed relationship.
- Sims told they can have sex with another Sim will no longer cause jealousy in their partner if they are having sex with the Sim they were told they can have sex with.
- DD now overrides vanilla Jealousy, all of the current checks of DD jealousy now work with vanilla jealousy.
- Slaves from Sim Snatcher will now ignore the Incest fetish requirement if given permission by their master to romance the other Sim.
- Devious Desires now requires at least version 1.2 of Deviant Core.
- Devious Desires now requires at least version 2.2 of Sims 4 Community Library.
- Sim Snatcher Slaves no longer require romance, fetishes, nor consent in order for their DIRECT master to perform the Sex, Milking, etc. interactions with them. (If they are at or above level 6 Obedience)
- When clicking on a Slave, instead of Fight and Rape, you will now see Use Slave.
- Sim Snatcher Slaves working at a Brothel no longer get despawned while working.
- The Try Intervene interaction is now properly tagged as a mean interaction, thus highly obedience SS Slaves will no longer be allowed to do them.
- Sex now increases obedience in Slaves if one of their Household Masters is involved in the act.
- Removed the Use Slave rape interaction.
- Slave Jealousy Changes:
  - (When "sex" is mentioned, it will apply for all sex types)
  - When a Sim starts sex with a Slave, the Sim partner will not get jealous at them.
  - When a Slave starts sex with a Sim, the Sim partner will get jealous at them.
  - When a Slave starts sex with a Slave, the partner of either will not get jealous at them.
  - Slaves can be told who they can be romantic/have sex with by their direct master without being in a committed relationship with them.
  - Slaves that are told they can have sex with each other ignore the romance and fetish requirements with each other the same as if the master was asking.
- Fixed an issue with Slave Sims attempting to do Rape interactions above obedience level 5 (Obedience level 5 is when SS slaves can no longer do mean interactions)

Version 5.1.2:
- Added checks to prevent some Sims from receiving Breast Milk, Cum, Feces, and Urine.
- Removed the duplicate "Maximum Patrons for Harlot/Stud" setting.

Version 5.1.1:
- The Lovense Detection notification should now only appear once when first loading into the game.

Version 5.1:
- When checking for gender compliance for animations, we now use the Attracted To Gender For Woohoo, instead of Attracted To Gender For Romantic.
- The Trigger Orgasm interaction will no longer be shown while Sims are performing an animation that does not have orgasm capabilities.
- Fixed an error when selecting the global part for Underwear.
- Fixed an issue when starting sexy time for a few animation types, such as Defecation On Objects, On Sims, Urination On Objects, On Sims, and various others, when starting with a solo Sim.
- Updated alot of the Human/Animal pregnancy stuff to be much cleaner and catch many more scenarios than before.
- With these changes, you may now see the correct species listed by Control Menu when viewing pregnancy info.
- Added Lovense Sex Toy support when Sims are having Sex.
  - Vibrations, Rotations, and Pumping is based on the level of orgasm for the Active Sim during sex.
- Devious Desires now requires at least version 1.1 of Deviant Core.
- Devious Desires now requires at least version 2.1 of Sims 4 Community Library.
- Added a unique rape interaction when clicking on Sim Snatcher Slaves called Use Slave.
- When a Sim is defecating on the ground, DD will now check if Cats and Dogs DLC is available before trying to create the poo pile.
- Fixed an issue when starting sexy time for a few animation types, such as Defecation On Objects, On Sims, Urination On Objects, On Sims, and various others, when starting with a solo Sim.
- Updated alot of the Human/Animal pregnancy stuff to be much cleaner and catch many more scenarios than before.
- With these changes, you may now see the correct species listed by Control Menu when viewing pregnancy info.
- Added a unique rape interaction when clicking on Sim Snatcher Slaves called Use Slave.

Version 5.0.1:
- Changed the mod_data location to be entirely based on what S4CL specifies rather than hardcoding it.
- Also moved the mod_data folder back to The Sims 4/Mods/mod_data instead of The Sims 4/mod_data

Version 5.0:
- REMOVE "deviousdesires_wickedwhims_loader.ts4script" or your game will simply NOT LOAD (Because of errors)!
  - Deviant Core natively loads WW animations and CAS Parts, so this file is no longer needed.
- Moved many utilities/classes to S4CL.
- Split out much of the Animation and CAS Part code into Deviant Core.
- Fixed some issues with Nudity, it is much faster to change things to nude, underwear, or outerwear.
- The strapon interaction is now separate from the normal interactions. Equip Strapon and Remove Strapon are now under the Devious Desires menu.
- Improved the performance of the start animation interactions as well as the nudity interactions. The delay before interactions appear is much smaller now.
- When Sims undress to their Nude, Underwear, or Outerwear, they will now animate doing it. The animations have some variants to them.
- Equipment interactions have been moved out of Instant Outfit and into an Equipment menu instead.
- The By Location interactions have been removed and replaced with a singular By Slot interaction instead.
- All instant outfit DD interactions have been moved to the SHIFT+CLICK cheat menu under Equipment.
- Decreased the amount of time it takes to load from the main menu into a household as well as when travelling to different lots.
- Fixed an issue where Robots and Skeletons would unequip their full body outfits whenever they got undressed.
- Added support for Scarecrow Sims. (Though a penis still needs to be made available for them, since they have skinnier wastes than normal Sims)
- Clothing Piles will no longer spawn during animations.
- Fixed an issue where Genital Skin Overlays were not always being applied to Sims properly.
- DDWWLoader has now been integrated into Deviant Core. Ensure you remove "deviousdesires_wickedwhims_loader.ts4script" since it is no longer needed.
- Fixed an issue where the skin overlays were not being applied when unequipping all body parts.
- Added snippets for Scarecrow Full Body, Hard Penis, and Strap-ons (They use MiniGiles Skyrim Dildos as a Penis)
- Added snippets for Skeleton and Robot Hard Penis (They use MiniGiles Skyrim Dildos as a Penis)
- Fixed an issue where solo fetish interactions were visible, even on Sims without any fetishes.
-----DD Kinky-----
- Fixed an issue with Sims being able to intervene for Sims in Rape when they were not supposed to be able to.
- Fixed an issue with Sims becoming Jealous at the Victims in a Rape animation.
-----DD Brothels-----
- Added a new phone icon for DD Brothels.
-----DD Dirty Play-----
- Fixed the display text on the Ask To Defecate interaction.
- Devious Desires requires at least version 1.0 of Deviant Core.
- Devious Desires requires at least version 2.0 of S4CL

Version 4.3.3:
- Fixed an error that would occur on travelling to a brothel lot for work.
- Fixed an error that would occur when spawning laundry clothing piles for a Sim that is no longer spawned.
- Fixed an error that was causing the Unpack pill container interaction to appear on all objects EXCEPT actual pill containers.

Version 4.3.2:
- Updated Sexual Organ Preference code to work with the changes done to Sexual Orientation ingame.
- For things to properly work, it is recommended to run the S4CL command at least once to fix Gender Preferences and thusly Sex Classification Type preferences! "s4clib.apply_default_gender_pref_to_all_sims"
-----DD Dirty Play-----
- Fixed an issue with the Urinate In Front of interactions having blank text.
-----DD Brothels-----
- Updated a few brothel tunings to work with the current patch version of The Sims 4. 1.90.358.1030 (High School Years)
- Devious Desires now requires your game to be up to at least version 1.90.358.1030 (High School Years)
- Devious Desires now requires at least version 1.80 of Sims 4 Community Library.

Version 4.3.1:
- Removed some test code I accidentally left in that was causing WW to throw a bunch of errors unintentionally.


Version 4.3:
- -----DD Base-----
- Added a setting to allow Sims without breasts to take actor slots that require breasts
- Improved the load times of WW Animations, WW CAS Parts, and WW Dance Animations
- Cleaned up the Start Sexy Time dialog, it now shows all animation types dynamically.
- Animation Runners (Basically Sex) now run on game time.
- Fixed an issue with the green progress bar on animation interactions.
- Fixed an issue when a Sim is having an orgasm when the animation ends.
- Arousal now increases based on game time, rather than real time.
- Added a Morning Wood buff that applies to Sims that have just woken up. (It gives these Sims an erection lasting about 20 Sim Minutes.
- When Sims become erect while wearing their underwear, they may equip an underwear variant showing off their erection. (If CAS Parts are available for it.)
  - It will also equip selected skin overlays at the same time!
  - Sims must have a regular underwear selected before they can equip a hard penis variant.
  - Currently the selection of which hard penis underwear to use is completely random. It may be based on tags, game tags, and custom tags of the regular selected CAS Part in the future however!
- Added a ton of the Noir female hard penis in panties CAS Parts to DD (via snippets, not the actual CAS Parts themselves, have to download those separately!)
  - "Hard on My CK (NOIR FUTANARI PENIS)"
  - "Very Hard on My Thong (NOIR FUTANARI PENIS)"
  - "Very Hard on Shecock Bow Thong (NOIR FUTANARI PENIS)"
  - "Very Hard on Shecock Fullbody Lingeire (NOIR FUTANARI PENIS)"
- Added a new CAS Part type UNDERWEAR_FULL_BODY.
- Overhauled the CAS Part tagging system. CAS Parts may now be tagged with three different types of tags DDCASPartTag, CommonGameTag, and Custom Tags (which are just text)
  - Added CAS Part Tags:
    - NATIVE
    - PRIMARY
    - SECONDARY
    - REVEALING
    - VAGINA
    - PENIS
    - HAS_VISIBLE_PENIS_BULGE
    - ERECTION
    - FEMININE
    - MASCULINE
    - SIZE_SMALL
    - SIZE_MEDIUM
    - SIZE_LARGE
    - DISALLOW_FOR_RANDOM
- Added "required_rig_version" and "required_rig_bones" properties to both CAS Part and Animation snippets.
  - This will allow animators and CAS Part creators to specify which bones they require to be on the rig.
- Enabled the ability to select custom tongues in DD.
- Fixed an issue when selecting None for Underwear Top or Bottom.
- Removed the has_visible_penis_bulge property from underwear to use the tag for it instead.
- If a Fetish type if disabled, animations associated with it will now be filtered out.
- When using Start Sexy Time to select animations, the animations will no longer be filtered using the disallow for initial filter filter.
- Fixed an issue with Skin Overlays not being properly attached to Sims, even when they are selected.
- Fixed an issue with Skin Overlays not properly being read from saved data.
- Updated the required S4CL version in the install check. It properly looks for 1.78+ now. (Instead of 1.77+)
- Added Condom and Birth Control functionality:
  - Sims cannot cause pregnancies in other Sims if they are wearing a condom.
  - Sims cannot become pregnant if they have taken birth control pills.
  - Generic Condoms and Birth Control Pills can be brewed/crafted on a stove using level 3 herbalism skill.
  - Contraceptives can be purchased in the Purchase Gifts dialog.
- Sims will no longer stop sex out of jealousy autonomously if they aren't even in the same room as the sex.
- Added animation tag DANCING_STAGE
- When Sims are in solo sex, the Previous button will no longer display on the first page of the choose cum location dialog.
- Added configuration settings to the deviousdesires.config file to toggle the start up notifications for animations, cas parts, and encounters loading.
- Fixed an issue when adjusting motive levels where the game would not register they had changed.
- When a Sim is pregnant, they will now gain arousal 10% faster.
- Sims may now offer consumables to other Sims.
- Sims can now autonomously join sex only if they are within the same room. Instead of from across the map.
- Animations are now cached
  - Cached data is located in `Mods/mod_data/deviousdesires/caches`
  - On first load it will take a normal amount of time. On second load, it will be faster.
  - The caches will update only when Animations are added, but not when they are removed.
- Pulled xml generation of converted animations and CAS Parts out of the actual reading to speed it up at least a little bit.
- Added how many duplicates and how many invalid items were found when loading CAS Parts, Animations, and Encounters
- Added a setting to toggle display of the autonomous interactions normally hidden from the player. (For debug purposes)
- When all Sims have the same animation role preference, some of them will be randomly assigned different preferences to make locating animations easier.
- Added debug notifications that indicate why a pregnancy may have failed. This debug can be enabled in the DD Settings -> Global -> Sex -> Pregnancy -> Enable Pregnancy Debug
  - This may also hopefully help people to stop trying to tell me that pregnancy doesn't work!
- Reworked the Hidden Pregnancy buff
  - When a Sim has a Hidden Pregnancy they may either take a pregnancy test or they can simply wait 24 Sim hours for a pregnancy takes effect.
- Fixed an issue when the ANYWHERE option is selected in the Preferred Cum Location dialog
- Fixed an issue with clothing piles not spawning upon removing clothing parts.
- Fixed an issue when assigning fetishes to Sims where we were reassigning fetishes on Sims via the templates, even if they already had randomized fetishes.
- Fixed an issue with solo interactions not account for both giving and receiving a fetish
-----DD Dirty Play-----
- Added new fetishes, animation types, and interactions Defecation On Sims, Defecation On Objects, Urination On Sims, and Urination On Objects.
  - While Sims are defecating on the floor, they will create feces piles. Small, Medium, Large.
    - The longer they defecate, the large the pile becomes.
    - These piles can be consumed by Sims that are into Consuming Feces.
    - These piles can collected into single servings and stored in the fridge. They will also be used as leftovers.
  - While Sims are urinating on the floor, they will create urine puddles. Small, Medium, Large.
    - The longer they urinate, the larger the puddle becomes.
    - These puddles can be consumed by Sims that are into Consuming Urine.
    - These puddles can collected into single serving glasses and stored in the fridge. They will also be used as leftovers.
  - Added new Animation Types Defecation On Sims, Defecation On Objects, Urination On Sims, and Urination On Objects.
  - Added new animation tags `DEFECATION_ON_SIMS`, `DEFECATION_ON_OBJECTS`, `URINATION_ON_SIMS`, and `URINATION_ON_OBJECTS`.
  - Added animation actor tags `FECES_NON_BATHER`, `FECES_BATHER`, `URINE_NON_BATHER`, `URINE_BATHER`, and `PUKE_NON_BATHER`
  - When Sims have a bladder failure, they will create urine puddles instead of water puddles.
  - When werewolves mark their territory, they will now produce a urine puddle instead of a water puddle. (With DD Dirty Play, of course)
  - When Animal Sims poop on the ground, they will now produce DD Dirty Play feces instead of the normal poop.
  - Added Large, Medium, and Small Golden and Rainbow Feces Piles.
  - Added Golden Bar Feces Piles
  - Feces and Urine containers can be bought as grocery items.
  - Sims can no longer throw the feces piles away as if they are pet poop
  - Feces piles will be placed in the inventory of the Sim creating them so that they can create more feces piles throughout the animation.
  - Urine containers will be placed in the inventory of the Sim creating them so that they can create more urine puddles throughout the animation.
  - When Sims defecate, they will now play a defecation vfx indicating as such.
- Added a setting to adjust the required amount of bladder and bowels required for autonomous Scat interactions
- Added a setting to adjust the required amount of bladder required for autonomous Watersports interactions.
-----DD Pet Play-----
  - Leashed Sims will now use the werewolf run walkstyle when moving.
-----DD Milk Farm-----
  - Breast Milk and Cum can now be bought as grocery items.
  - Fixed an issue with the milk levels showing values above 100%
  - Fixed issues when DD attempts to increase the skill of a Sim that is no longer spawned.
  - Sims wearing a condom can no longer cause inflation in other Sims.
  - Fixed an issue with Breast Milk and Cum when Sims grab them as left overs where they were performing the wrong interaction to consume them.
  - Fixed an issue where Sims would not autonomously drink single Breast Milk or Cum glasses when they are placed outside of a fridge.
  - The supplement buff durations has been increased from 24 to 72
  - The Recently Milked buff durations have been decreased from 4 days to 1.5 days
  - When a Sim is pregnant, they will now produce breast milk 20% faster.
  - When a Sim has the Good Workout buff, they will now produce Cum 15% faster.
  - Update the models of the medium sized cum containers
  - When Sims have a high level of inflation or they have a high amount of stored milk they will begin to leak, producing effects and puddles.
    - Added settings to toggle the leakage effects and puddle of Breast Milk and Inflation.
    - Added settings to set the percentage chance of creating puddles when Sims leak.
-----DD Kinky-----
  - Sims will no longer try to intervene rape autonomously if they aren't even in the same room as the rape.
-----DD Pets-----
  - Added pet treats to equip a condom on animals as well as for birth control. They can be bought at vet clinic vending machines.
- DD now requires at least version 1.79 of Sims 4 Community Library.

Version 4.2.5:
- Fixed an issue with `SERVO_MALE` loading as `ADULT_HUMAN_WITCH` instead of `ADULT_HUMAN_ROBOT` in the DDWWLoader
-----DD Anthros-----
  - Added `WEREWOLF_PENIS_HARD` support to the DDWWLoader
-----DD Milk Farm-----
  - Fixed an issue where a Sim would never be able to produce a pregnancy or apply overlays if the amount of cum lost on orgasm setting had a value higher than the max capacity of the Sim.
  - Fixed an issue with Sims losing more Cum than they have stored.

Version 4.2.4:
- Fixed an issue where Fetish Traits were being removed from newly created Sims and when travelling to another lot.
- Arousal now increases based on game time, rather than real time.
- Animation Runners now run on game time. (Basically Sex)
- Fixed an issue with the green progress bar on animation interactions.
- Fixed an issue when a Sim is having an orgasm when the animation ends.

Version 4.2.3:
- Fixed the Show Choose Cum Location Dialog When Sex Involves setting not actually being used.
- Fixed an issue with pregnancy showing the "might be pregnant" dialog at zero percent chance of pregnancy.
- Updated the Sim rig.
- Each module now keeps track of its own settings, so they are not all put in the global settings file. (This unfortunately means that all of their settings have been reset)
- -----DD Milk Farm-----
  - Fixed an issue with the recently milked buff not refreshing after milking.
  - Mobile milking will now apply the recently milked buff (and will also refresh it properly as well)
  - Fixed an error with some Milk Farm recipes that had the wrong first phase specified
  - Added a setting to be able to toggle who to show the Lost Production Skill notification for.
  - Fixed an issue when removing the production skill expiration buffs.
  - Added settings to disable the production skill degradation for Breast Milk and Cum.
  - Split the Milk Farm System settings from the global settings.
- -----DD Pets-----
  - Updated the DD Pets setting to toggle knotting to only have an effect on Animal Sims.
- -----DD Anthros-----
  - Added new package DD Anthros.
  - Moved the Knotted Penis trait to DD Anthros from DD Pets. (You no longer need to install DD Pets to use this trait)
  - Added a new setting to DD Anthros settings for toggling knotting.
  - Added penis and testicle bones to the werewolf rig
- Devious Desires now requires at least version 1.78 of Sims 4 Community Library.

Version 4.2.2:
- Fixed an issue where Sims would not have an orgasm if not climax animations were available for the location they were having sex at.
- Fixed an issue when Sims try to autonomously start an animation and they choose a floor animation.
- -----DD Milk Farm-----
  - Fixed an issue with Breast Milk, Cum, and Inflation levels stopping updates when changing zones.
- -----DD Pets-----
  - Fixed an issue with the knotting buff immediately turning into the Pull Knot buff upon a Sim with a penis knot having an orgasm and knotting.

Version 4.2.1:
- Fixed the Conflicting Rig error if you are using WW.

Version 4.2:
- -----DD Base-----
  - Cleaned up the jealousy reaction
    - During sex, Sims will no longer constantly be losing reputation again and again due to jealousy.
    - Added notifications that appear when Sims stop sex out of jealousy
    - Fixed an issue where the Stop Out Of Jealousy Interaction did not account for the target Sim having the Player trait.
  - Added separate Watch interactions so that Sims into the animation, won’t boo it and Sims not into it, won’t cheer for it.
  - Added height slider support for CSF height sliders as well as a couple of o19 sliders.
    - When an animation begins, the height of Sims will be reset to zero, when sex ends, their height will go back to normal.
  - The sexperience buffs Sims normally get after sex have been moved to Sentiments (Interacting with the other Sim will give the same sexperience buffs after sex has finished)
  - Moved some hardcoded strings to string tables
  - Added an interaction to masturbate to porn on the computer.
    - When Sims are masturbating to porn on a computer, they will now learn fetishes every 30 Sim minutes.
    - Added allowance flags for porn watching
    - Added animation type `PORN_WATCHING`
  - Added a Test that will check if a Sim has a fetish for another Sim.
  - Added a function to DDAnimationRunnerContext that allows creating allowance flags specifically for join.
  - Cleaned up the Encounter and CAS Part query utils.
  - Added "Not Implemented" next to the names of fetishes that have not been implemented.
  - Fixed the error that would occur when Sims attempted to start autonomy and something was checking for ParticipantType.Listeners when it did not exist.
  - Sims will now check if they can actually reach another Sim before trying to start an animation with them autonomously.
  - Added a check for if a Sim can reach another Sim when starting animations with them manually.
  - Reordered some of the checks for various interactions so that target objects are checked for animations before they are checked for being allowed to interaction with them, specifically with regards to starting animations.
  - Fixed an issue where Solo interactions were not appearing when clicking on objects.
  - ---Settings---
    - Changed the default max total time in animation from 360000 ms to 60000 ms
    - Changed the default max time per animation from 60000 ms to 30000 ms
    - Added a setting to toggle the usage of the NO_STRAPON_ALLOWED tag
  - ---Animation Customizations---
    - Added animation tag `SEXUAL_NETWORK`, `CLIMAX_ON_FLOOR`
    - Added animation actor tags `IS_USING_COMPUTER`, `IS_USING_PHONE`, `IS_USING_TELEVISION`, and `IS_CREATING_SEXUAL_NETWORK_PROFILE`, `NON_PARTICIPANT`, `ORGASM_PENILE`
    - Fixed an issue with sexual organs and unequip type customizations not properly converting to operations.
    - Fixed an issue where Animation Customization was not properly applying backwards compatible customizations when no current customizations were available.
    - Fixed an issue where Animation Customization was not properly applying backwards customizations to current customizations and causing the current customizations to become overridden.
    - Fixed an issue where Animation Customizations was not properly updating the operations for adding/removing sexual organs, animation actor tags, unequip types, unequip body types, overlay body locations, and animation tags
    - Fixed an error with the Unequip Types dialog when customizing animations and the animation has all unequip types selected.
  - ---Animations---
    - Animations will no longer auto unequip bottoms if an actor slot requires Penis or Vagina
    - Dancing animations will no longer increase sexperience skill.
    - Dancing animations will no longer increase dancing skill for Sims not actively dancing.
    - Fixed an issue with Sims no longer being erect during animations.
  - ----Actor Role Preferences update----
    - Added the ability to set what actor roles a Sim prefers.
    - Removed the setting of Top and Bottom as a Sims preference in favor of the new system.
    - Instead of Top and Bottom in Animation Customization, it is now Preference Giving It and Preference Receiving It.
    - Sims that have actor role preferences will now prefer taking actor slots that match their preferences
      - Animations can now be filtered on Actor Role Preferences of Sims. This can be toggled on in the DD Settings (Off by default due to the lack of animations available for those tags)
    - Sim Actor Role Preferences are automatically assigned to Sims based on their sexual organs. (If they do not already have a preference)
  - ----Orgasm Changes----
    - Changed how all of the orgasm code works, now it triggers via events and Sims that have an orgasm will trigger the event when it is time to have said orgasm.
    - Changed how orgasm logic is handled. Instead of Sex checking over and over if Sims are ready to have an orgasm, they will instead only check WHEN a Sim has an orgasm.
    - The switching to a climax animation interaction is now also triggered on an event.
    - Fixed an issue with the trigger orgasm interaction where an animation change would happen even when the change to climax animation setting is disabled.
  - ----Cum Location----
    - Preferred Cum Locations now have you specify a target. This allows for more freedom when Sims have an orgasm.
    - When choosing a Cum Location, new options are available:
      - Floor - This will make the Sim shoot their load on "the floor", i.e. do nothing with overlays, pregnancy, etc.
      - Let The Animation Decide - This will do whatever the animation has dictated as actions for the actor having the orgasm. (Use ANimation Customizations to see this.)
    - When NPC Sims have an orgasm, they will now choose from the same Cum Locations the player does (but randomly) rather than solely relying on what the animation actions say to do. This can lead to more pregnancies during NPC sex.
    - Removed the Show Cum Location Dialog When Target Is Self setting
  - Added a setting to toggle the Object Is In Use check, this setting only has an effect when manually starting animations. Sims starting animations autonomously will still check for an Object Being In Use.
  - Added settings to toggle the Hard Reset of Sims at the start and end of animations and Objects at the end of animations.
  - Fixed an issue with the Use Actor Role Preferences When Querying Animations setting.
- -----DD Kinky-----
  - Cleaned up and overhauled Rape Intervene.
    - The player may now initiate an Intervene to fight the Rapist Sims themselves.
    - Added notifications that appear when Sims stop sex by attempting to intervene.
  - Added the Rapist Sims are the only ones allowed to rape tooltip text to the DD Kinky string tables.
  - The "Only Rapists can rape" tooltip will now only display on objects that have animations.
- -----DD Pets-----
  - Cleaned up many of the pet romance interactions. (Moved some checks for their availability into the code)
- -----DD Milk Farm-----
  - Changes:
    - Sims that either do not produce or have basic milk production will now see their breasts/testicles scale, but at half the maximum size as a Sim that produces upgraded.
    - Swelling of the breasts will now scale Chest Depth and Breast Separation
    - Swelling of the testicles will now use both available sliders from CSF.
  - Fixes:
    - Sims that do not produce cum upgraded will now inflate at half the amount as a Sim with the trait.
    - Fixed issues with inflation and swelling where the Sims would not reset back to their original sizes.
    - Fixed an issue with testicles not swelling properly.
    - Fixed an issue where Sims were receiving multiple swelling buffs at the same time.
  - During breastfeeding, breast milking, cum consumption, penis milking, feces consumption, and urine consumption, the amount of fluids lost by 
    the sources is now proportionate to the number of other Sims in the same animation that are also sources of those fluids. So with 2 Sims being
    the source of Cum, they will lose only half the amount of Cum they normally would.  
  - Added the ability to join Breastfeeding, Breast Milking, Cum Consumption, and Penis Milking animations.
  - Updated the milking bar, it can no longer be used as a table.
  - Customized the Milking My Beau by MISSME animation on the milking bar
  - Sims that produce Cum will now be able to apply cum, create pregnancies, and can choose a preferred cum location, regardless of whether they have a penis or not.
  - Milk Farm animations will no longer increase sexperience skill.
  - Milking now runs on Sim time rather than real time
  - Milk Levels and Inflation Levels are now updated based on Sim Time, rather than Real Time, so every Sim Minute instead of every real Second.
  - The Breast Milk and Cum levels of Sims will no longer increase while they are being milked from their breasts/penis in an animation.
  - Added new medium sizes containers for Breast Milk and Cum. These containers come with four servings each.
    - Only Sims that are into consuming Breast Milk will be allowed to consume/grab servings/be called to meal for the Breast Milk fluid containers.
    - Only Sims that are into consuming Cum will be allowed to consume/grab/be called to meal for the Cum fluid containers.
  - Added Breast Milk Production skill and Cum Production skill. These skills will modify the storage capacity for each fluid, increasing by 10% each level.
    - The rate at which milk and cum levels increase is now influenced by the Breast Milk and Cum Production skills.
    - Sims that are milked can now influence milk/cum quality using their production skill level.
    - Sims will now gain production skill while being milked and while feeding other Sims.
    - The Breast Milk and Cum Production skills will now degrade over time.
    - The amount a Sim will inject into another Sim upon orgasm (inflation) will increase in amount based on the Cum Production skill.
  - Breast Milk and Cum containers are now seen by Sims as leftovers, meaning they may choose to grab those when they are searching for leftovers.
    - In order for a Sim to grab Breast Milk containers as leftovers, they need to be into consuming Breast Milk (Fetish).
    - In order for a Sim to grab Cum containers as leftovers, they need to be into consuming Cum (Fetish).
      servings of the fluid containers.
  - Breast Milking, Breast feeding, and Breast Milk Production no longer requires a Sim to have breasts.
  - Penis Milking, Cum Eating, and Cum Production no longer requires a Sim to have a penis.
  - Changed the Show Milk Levels interaction to a normal interaction and renamed it to Show Production/Inflation Info
  - The Show Production Info interaction now shows much more detailed information.
    - It now displays production max capacity, rate of production.
    - It now also shows details about inflation, rate of loss (How much inflation level is lost per second/Sim minute) and the amount of inflation applied the Sim will apply to other Sims when they have an orgasm.
- -----DD Brothel-----
  - Added Brothel settings for setting which types of patrons are allowed by Age and Gender
  - Updated the brothel settings with the brothel icon
  - Fixed an issue with Brothel Perks not properly staying bought after purchase.
  - Added a command to add brothel perk points `ddbrothel.add_brothel_bucks`
- -----DD Pet Play-----
  - DD Pet Play Do Business now requires DD Dirty Play to be enabled.
  - DD Pet Play Poo On Ground now requires Scat to be enabled.
  - DD Pet Play Pee On Ground now requires Watersports to be enabled.
  - Fixed an issue where the normal interactions for pets on a leash were unavailable
- -----DD Dirty Play-----
  - During feces consumption, and urine consumption, the amount of fluids lost by 
    the sources is now proportionate to the number of other Sims in the same animation that are also sources of those fluids. So with 2 Sims being
    the source of Feces, they will lose only half the amount of Feces they normally would.
  - Added the ability to join Feces Consumption and Urine Consumption animations.
  - Dirty Play animations will no longer increase sexperience skill.
  



Version 4.1.4:
- Fixed an issue where animation customizations were unintentionally removing animation tags from animations when they were applied.
- DD now requires at least version 1.77 of Sims 4 Community Library

Version 4.1.3:
- Major clean up and fixes around During sex stuff.
- Fixed an issue with the customization dialog not properly filtering using a target object.
- The Show Available Animations dialog has been upgraded with new selections to filter animations by. You can filter by species, author, category, and tags.
- Sim Context now requires allowance flags to be passed in to them.
- Updated sex preference tags, so they are read as actor tags instead of as strings (They have also been renamed to animation_preference_tags).
- Allowance flags are now serializable.
- Added PLAYER_CLUB_GATHERING from DDAnimationCreationReason
- Removed BROTHEL from DDAnimationCreationReason
- Added a customization for MercuryFoam pole dancing animation to be  marked properly as pole dancing.
- Switched the body location and amount arguments of the DD Milk Farm commands for setting milk/cum/inflation levels.
- Fixed a couple issues when assigning Sims to actor slots for Dancing, Milk Farm, and Dirty Play interactions.
- Fixed props not properly being placed where they should be at the start of sex.

Version 4.1.2:
- During Sex Stuff:
  - Updated can_change_animation to return CommonTestResult as well as be a function instead.
  - Overhauled DDSex to be a series of DDAnimationRunner for future plans to further clean it up and make each animation type have its own animation runner, so that tests/actions/functions specific to those animation types will be limited to those animation types and we will not need to check what type of animation it is.
  - Fixes:
    - Fixed a few issues when applying Cum Overlays to Sims.
- Animation Customizations:
  - Changes:
    - Added the ability to combine main.json and my_own_customizations.json with other files.
    - main.json is now available for selection when choosing customization files.
    - Added a description to the main.json file when it shows in the "choose customization file" dialog, now it'll indicate that any changes made to it will not be saved.
  - Fixes:
    - Fixed an issue with some operations not properly applying in animation customization
  - main.json
    - Customized many new Pole Dancing animations to be for Pole Dancing.
- Misc:
  - Additions:
    - Added the `NO_STRAPON_ALLOWED` animation actor tag.
      - This tag is used when a Sim with a Vagina is searching for an animation and they are allowed to use a strapon. This tag makes sense in cases such as when the Sim with the penis would be jerking off their penis while giving a blowjob to another Sim, it doesn't make sense to jerk off a strapon, thus it would have the `NO_STRAPON_ALLOWED` tag on that actor.
    - Added more types of test set instance tunings for Is Enabled For Interaction checks (Planned to be used in the future)
  - Changes:
    - New images for Brothel lessons.
    - Flipped the body location and amount arguments for many of the DD Milk Farm commands for setting milk levels and inflation levels.
  - Fixes:
    - Fixed an error when loading into a game from a save made in an open brothel

Version 4.1.1:
- Fixed a strange error that occurs only for some people when Sims spawn.
- Updated the rest of the DD commands to use the new CommonConsoleCommand. Which means they will show up when doing `deviousdesires.help`

Version 4.1:
- Alot of these changes have led to an increase in performance when clicking on things, while the game is running, and when loading into a zone.
- Start Sex (and other Fetish types) Overhaul.
  - All fetish interactions such as Milking, Breastfeeding, etc. are now locked behind the fetish traits. Thus, if your Sim does not have the fetish trait associated with the fetish, they will not be able to do it.
  - The only non locked ones are Normal Sex and Rape. (All Sims can do both of these)
  - Created an interaction that leads into Multi and Solo Sim sex
  - Changes:
    - Breastfeeding no longer requires a large amount of stored milk to autonomously start it.
    - Cum Consumption no longer requires a large amount of stored Cum to autonomously start it.
  - Fixes:
    - Fixed an issue where Lure and Rape was notifying about raping friends/romances, even if it wasn't
    - Fixed an issue with Fight and Rape showing up when it shouldn't
    - Fixed an issue when NPC Sims try to autonomously interact with the Active Sim
- During Sex:
  - Sims will no longer gain romance if sex involves more than two Sims.
- Join Sex Overhaul.
  - Sims will now ask to join sex autonomously more often
- Watch Sex (Be Aroused) Overhaul
  - If a Sim sees sex, they will watch the Sims going at it. They may even join in on the fun! (They do not need to be aroused to do this anymore)
- Animation Customizations
  - Added the ability to filter animations by Tags, Author, Category, and Species.
  - When modifying tags, they can now be selected by category. (Or you can select from the entire list of them as before)
  - Added the ability to combine customization files
  - Added the ability to choose a specific customization file to save any new customizations into.
  - Customizations now work off of an operations system, where each change made to an animation is apply sequentially, instead of having one customization file completely overriding changes of another customization file.
  - Fixes:
    - Fixed an issue with some animations not being able to show due to the large number of custom locations they specify.
    - When opening a dialog with a ton of animations in it, it will no longer take forever to build the dialog. The animations will show a shorter version of their normal description.
- Fetishes:
  - Added Fetish Templates
    - With fetish templates, you now have the ability to save a set of fetishes that can readily be applied to Sims. Those Sims will have their fetishes match the template entirely.
    - These fetish templates will also be randomly chosen from and applied to Sims without fetishes as well. (The old system where it applies random fetishes to Sims will still apply, if a fetish template is not applied to them.)
      - The chance of applying a fetish template can be modified in the DD settings.
    - These fetish templates can also be shared with other people as well.
  - Removed the Seeing Giving and Seeing Receiving portions of fetishes. (They made sense in real life, but in the video game world, it just makes things complicated)
  - Many fetishes that don't have both a Giving and Receiving side to them now only have a single "side", such as Incest and Exhibitionism.
  - Fixes:
    - Fixed an issue with fetish preference traits not being properly added to Sims.
- Created a new module specifically for Pet Play.
  - Leashing is now locked behind the pet play fetish.
  - The leashing interactions have been moved to the Pet Care category.
  - When a Sim is leashed, they will now wear a collar that the leash attaches to.
  - Leashed Sims can now be taken for a Jog or a Walk.
  - Leashed Sims can now "Do their business", if DD Dirty Play is installed. (Animations for these interactions still need to be updated though, so you may see the Leashed Sim morph all weird!)
  - Fixes:
    - Fixed an issue with the leash not properly attaching to the neck of the leashed Sim.
- Start Sexy Time Changes:
  - Normal Sex start no longer has select targets, it is now a single dialog for selecting Sims, then you select animations right after.
- Misc Changes:
  - Renamed Cum Eating to Cum Consumption
  - Renamed Poo Eating to Feces Consumption
  - Renamed Pee Drinking to Urine Consumption
  - Renamed Drinker to Consumer in the code
  - Renamed Eater to Consumer in the code
  - Removed pointless properties from DDAnimation and DDAnimationActor
  - Split all of the allowance flags, one for each of the special fetish types
  - Split all of the Allowed to Have Sex code into their respective modules
  - Cleaned up the animation query utils, it is much cleaner and much more performant now. (These changes have sped up a ton of other things in the process!)
  - Cleaned up the item querying system, tag filters, and tag handlers.
  - Changed many functions in DDSexContext and the properties in other contexts related to Sex to properties, since it makes more sense for them to be properties.
  - Object filter is no longer shoved into a DDCustomTagsAnimationTagFilter, it can be used directly now.
  - Added an animation test that checks for an animation to be allowed for random. Animations not allowed for random will no longer be selected at random.
  - Added missing is available tests for CAS Parts and Encounters
  - Added DD Trait class for better checking of which Sims can have a trait added to them.
  - Updated all traits to have a better check for which Sims are allowed to have those traits.
- Misc Fixes:
  - Fixed slowness when clicking on Sims or on locations due to the sex interactions being slow
  - Fixed an issue with the From Sim animation interactions using the wrong pirate day text
  - Updated the Lone Wolf And Loving It and Hungry For Animal Romance lifestyles only Zoophiliac Sims are able to receive them now.
  - Created missing CAS Preference Tunings for each of the fetish traits, not having these caused "preference_item" to not be found, which caused the interior decorator gigs to not work quite right.

Version 4.0:
- Fixed a bug with fetishes when trying to apply them in CAS through the LIKES/DISLIKES
- Fixed a bug with Mouth pregnancy, where it would not work at all.
- Fixed an issue when using the vanilla female vagina with Male Sims where it would not properly equip on them.
- Added dancing interactions that will allow your Sim to do dancing animations wherever you want.
- The DDWWLoader can now read WW Dance Animations.
- Added the ability to bulk customize for the Dancing, Dancing Lap, and Dancing Pole tags.
- Cleaned up the animation customizations dialog so the Dom/Sub and Aggressor/Non-Aggressor tags can be added separately.
- Fixed an issue when opening the Animation Customizations dialog from a Sim where it would become blank after choosing an author.
- Tagged many animations as dancing in "main.json"
- TONGUES can now be auto assigned to Sims that have not been assigned one.
- Fixed an issue that caused the genitals of Animal Sims not appearing.
- Added brothels
  - Added lessons related to brothel management that can be found in-game under the Lessons menu. ESC -> Lessons
  - Buy and manage brothels via the phone.
  - Added Harlots and Studs as a hirable job.
    - These workers will take the orders of patrons and fulfill their sexual desires.
    - More information can be found in the Lessons ingame, ESC -> Lessons -> Devious Desires -> Brothels
    - Added Player Job Harlot/Stud
      - Player Sims can now perform duties as a Harlot/Stud via a new Active Career. While on a Brothel lot, you can hire a Player Sim by clicking on them and choosing Hire as Harlot/Stud under the Brothel menu.
      - If multiple player Sims are hired for the same job, the player Sims not participating in the career event will perform their actions autonomously.
  - Added Strippers as a hirable job.
    - Strippers will socialize with patrons and perform services at their request
      - When Strippers socialize with patrons, they will increase/decrease their star levels
      - Services include Lap Dances and Various Sex Acts
    - Strippers will also pole dance while patrons watch and give tips
      - While dancing, the strippers will strip their clothing after meeting certain tip thresholds.
      - Strippers may become tired while dancing and will take a break for a bit before continuing to dance.
    - Strippers can be designated to Dance, Socialize or a mix of both (No designation)
    - Added the ability to specify service spots for strippers to perform services or to pole dance at.
    - Added Player Job Stripper
      - Player Sims can now perform duties as a Stripper via a new Active Career. While on a Brothel lot, you can hire a Player Sim by clicking on them and choosing Hire as Stripper under the Brothel menu.
      - If multiple player Sims are hired for the same job, the player Sims not participating in the career event will perform their actions autonomously.
  - Added Maintenance as a hirable job.
    - Maintenance will clean up trash, clean objects, and repair objects.
    - Added Player Dream Job Maintenance
      - Player Sims can now perform the duties of the Dream Job Maintenance worker! Clean and Fix objects to your hearts content. Snooze on the couch and watch some of that TV. It is an absolute dream!
  - Added Bartenders as a hirable job.
    - Bartenders will tend and clean any bars you have on the lot.
  - Added a command to rehire staff members. `ddbrothel.rehire_staff`
  - Added NPC Brothels
    - They work the same as a regular brothel, but you can put them on any lot by simply adding the Brothel Lot trait!
    - Player Sims can watch and tip dancing Strippers, they can also request services such as Lap Dances or sex from Strippers that are socializing.
    - Player Sims can also do some work at NPC brothels by hiring themselves while on the NPC brothel lot. (Or if their career is already one of the Brothel careers, they can simply clock in)
- Minor cleanup with how object contexts are created, to make it simpler to create your own object contexts from objects, interactions, and locations.
- Made some changes to the DDWWLoader. For certain "errors" in snippets, DD will assume a default value instead of not loading the Animation/CAS Part. As one example, if the Author is missing, DD will assume the author is "Unknown", instead of not loading the Animation/CAS Part. This applies to certain other warnings as well. This change applies when loading animations or CAS Parts.
- Override the NPC soft cap to 50 (If it is not already at or above that) for all lots.
- Fleshed out the Sex Classification Types even more
- Added Sex Classification Type Preferences
  - Sex Classification Types preferences are auto generated based on the Sims Gender Preferences + Sexual Organ Preferences
  - The Sex Classification Type of a Sim is based on their Gender + Sexual Organs.
- Added Sexual Organ preferences
  - Sexual organ preference is by default based on the Gender preferences of Sims.
  - Added a command `dd.apply_default_sexual_organ_pref_to_all_sims` that will set the sexual organ preferences of Sims based on their existing gender preferences.
  - Added commands `dd.set_sexual_organ_pref_of_all_sims`, `dd.set_sexual_organ_pref` and `dd.get_sexual_organ_pref`
  - Whenever gender preferences are updated for Sims, their Sexual Organ preferences will also update to reflect the changes made, except its change will be based on the sexual organs the target they are interacting with has. (Whether they know it or not)
  - When Sims are deciding whether or not to flirt with another Sim, they will take their Sexual Organ Preferences into account.
- Integrated Sexual Organ preferences into the vanilla gender preferences, so whenever those update, the sexual organ preferences will also update the same amount.
- Added Actor Role Preference Type (This will be used to determine which actor slots a Sim prefers to take in an animation and should help with filtering/assigning actor slots in the future when the changes are made for that)
- Added three tags PREFERENCE_RECEIVING_IT, PREFERENCE_GIVING_IT, PREFERENCE_GIVING_OR_RECEIVING_IT to be used at a later time (It will make use of Actor Role Preference Types)
- Added new Animation tags SEX_TOY_USAGE_BDSM, SEX_TOY_USAGE_LARGE, BREAST_MILKING_MACHINE, PENIS_MILKING_MACHINE, PRAISING, BORING, ANAL_EXCLUSIVE, DISALLOW_FOR_NORMAL_SEX
- Added new Animation Actor tags HIPS, IS_GIVING_PRAISE, IS_RECEIVING_PRAISE, IS_BORED, IS_BEING_BORING
- Patrons will now order a random service type when ordering from the menu.
- Patrons will now order using the sex types they prefer, so they may get the correct harlot/stud.
- Updated the Show Actor Info debug interaction to display Sexual Organ Preferences, Gender Preferences, Preferred Sex Classification Types, Actor Role Preference Types
- Sims that have Cum, Milk, Scat, or Urine overlays on them now have a desire to clean them off in a shower/tub.
- New Skill Sexperience
  - Use this skill to influence other Sims sexually.
  - New interactions when reaching higher levels of the skill.
  - The higher this skill is, the better experience your Sims partners will have during sex!
    - Moodlets will apply to Sims after sex.
- Skeletons now work properly in Sex.
- Lowered the minimum required value for Orgasm fill rate from 0.5 to 0.01
- The Ask To Join workflow is much more reliable, Sims are more likely to join after witnessing sex and Being Aroused at it.
- Fixed an issue with the Hungry For Love and No Need For Animal Romance traits that would break the Sim Info Panel
- "Features" are now referenced as "Modules".
- Added a command "deviousdesires.help", which can be used to view all commands available for DD (At least ones I have updated to show up there).
- The Penis Erection buff no longer has an effect on mood.
- Added a Cheating fetish
- Added many new animation tags and animation actor tags.
- Removed the directional Right/Left animation actor tags in favor of a non directional tag for each.
- Moved the Select Body Parts and Select Equipment Parts interactions to the SHIFT+CLICK menu instead of the normal menu.
- The nudity interactions will now always appear under Instant Outfit, regardless of whether S4CM is installed or not. This is done to reduce confusing and so that there is only a single place they can show up at.
- Added an interaction called Call Surgeon to the phone under the new Body Enhancement category, which lets you call a Surgeon to change the shape and size of your body, it costs money to do the surgery!
    - Once you choose the type of surgery you need done, your Sim will head to the hospital to have it done (A rabbit hole hospital, not the one from Get To Work)
    - DD now utilizes ERO traits such as the size traits for Bulge, Chest, and Butt
- Changing the sliders in CSF will now result in size traits being added to Sims based on their new sizes as well Bulge, Chest, and Butt.
- Animations can now be performed in the water, such as in Pools or in the Ocean.
- Updated the nudity buffs to bring back custom body types (Body Types are just slots that CAS Parts can take, making custom ones means that CAS parts no longer need to conflict),
    - DD no longer has to care what a CAS part is flagged as being available
    for in the CAS Part itself (Gender, Species, etc.). Thus if a part is
    flagged is being only for Female Sims, your Male Sims may now equip it
    too! This will solve the "random" CAS parts issue when your Sim gets nekked.
- When the brothel business is closed, Sims can now freely do whatever they want.
- Fixed a calculation error when calculating the swell size for milk swelling and inflation swelling. This means that CSF breast, belly, and pregnancy sizes smaller than Zero are once again possible!
- Updated the Animation querying system to be much faster, much smoother, and overall much more sexy.
- After accepting Sex, Sims will now go to the sex location at the same time.
- While Sims are doing an animation, the text at the bottom left will now properly read the name of the animation.
- When Sims start an animation of any type, the notification saying this will now properly reflect what they are actually doing, instead of saying "Are having some fun" or "Are engaged in blah"
- Devious Desires now requires at least v1.76 of Sims 4 Community Library.

Version 3.9
- Fixed an issue where the Assignment Method for parts was not properly updating when closing the dialog.
- Fixed the icons within the Body Parts/Equipment selection dialogs.
- Multi sex autonomy settings are no longer required to be enabled for solo autonomy to occur for Poo Eating, Pee Drinking, Breast Milking, Penis Milking, Breastfeeding, and Cum Eating
- Added the ROUGH_SEX fetish
- Sims need to like ROUGH_SEX and be into DOMINATION or SUBMISSION in order to Dominate or Submit respectively. (Ignored when manually done)
- Fixed an issue where Sims that were not into RAPE that were the Victim were not able to be raped.
- Fixed an issue where Sims could get the Became Jealous buff, even if they weren't allowed to be jealous.
- Added Fight Rape interaction for Human x Human, Human x Animal, Animal x Human, and Animal x Animal
- Arousal increases are now entirely controlled by DD itself rather than letting the game handle them (Since it obviously can't handle them properly)
- The Basic Breast Milk Producer trait is now temporary. It lasts 14 days. If a Sim is pregnant, they will always have the trait, but will be removed after they stop being pregnant when the buff runs out.
- Fixed issues with the Be Jealous interaction where Sims that should not be Jealous were being Jealous anyways.
- Added tags IS_TRAINING_FOR_ANAL, PLEASURED_BY_SEX_TOY, HAS_FIREARM, HAS_SWORD, HAS_WEAPON, MOTIVE_*_NO_CHANGE (* is each motive), FINGERING_ORAL, TRAINING_FOR_ANAL, SEX_TOY_USAGE, INTIMIDATION
- Sims will now react negatively (A negative buff) to sex that involves fetishes they either dislike or don't have a preference for.
- Prevent the sex motive distress interaction from being played during sex
- Added settings to modify how fast Arousal goes up over time
- Added settings to modify how much Arousal is required for Sims to start or join sex.
- Fixed join autonomy, Sims will now join Normal sex if they are romantic with any of the Sims involved (and they are actually "into" the sex that is happening of course)
- Fixed Join Autonomy, if they are declined, they should find a place to masturbate properly.
- Sims can now become aroused (rather than Jealous), if the gender they have a preference for applies to all Sims involved in the Sex interaction, even if their significant other is involved.
- Sims will now become annoyed when they walk in and see Sex they don't like.
- Fetishes now appear in CAS for selection
- Removed/Combined/Added Fetishes.
- Reworked Fetishes a bit, now each fetish has four different types of actions the fetish is about. Doing the fetish to other Sims, Receiving the Fetish from other Sims, Seeing the fetish being done to other Sims, and Seeing the fetish being received by other Sims.
- Renamed the Blood fetish to Blood Consumption
- Fixed an issue with the intervene fight not happening after an intervene
- Added animation actor tags GIVING_TO_HORSE, RECEIVING_FROM_HORSE, GIVING_TO_COW, RECEIVING_FROM_COW, GIVING_TO_CHICKEN, RECEIVING_FROM_CHICKEN, GIVING_TO_DOLPHIN, RECEIVING_FROM_DOLPHIN, GIVING_TO_LLAMA, RECEIVING_FROM_LLAMA, GIVING_TO_RABBIT, RECEIVING_FROM_RABBIT, BEING_FISTED_ANUS, BEING_FISTED_VAGINA, BEING_FISTED_MOUTH, FISTING_ANUS, FISTING_VAGINA, FISTING_MOUTH, BEING_CHOKED, CHOKING_OTHER
- Added animation tags FISTING_ANAL, INTIMIDATION, FISTING_VAGINAL, FISTING_ORAL, CHOKING
- When asking Sims to join with the Always Accept setting enabled, Sims will now always accept the join.
- In order to perform the Enthuse, Complain, Think About Positive, and Think About Negative interactions, your Sim now needs to at least Like the fetish. (Fetish discovery and new ways to boost fetish levels will be implemented later)
- Added an interaction for modifying fetishes of Sims faster. SHIFT+CLICK on Sim -> DD -> Modify Fetishes
- Fixed an issue where Servo Sims were unequipping their robot parts during sex. (If your robots continue doing it, make them the active Sim, then do the "dd.force_body_initialize" command)
- Removed the ANUS sexual organ to increase performance (Since all Sims have an Anus anyways)
- Fixed an issue with how Orgasm works. If one Sim had an orgasm, no other Sims could have an orgasm until the animation changed.
- Disabling the automatic animation progression setting will now properly prevent a change of animation.
- Fixed an issue with the Advance Animation interaction when the automatic animation progression setting is disabled
- Fixed an issue when starting sex on a chair that is connected to a table, where the Sims would be flipped 180 degrees.
- Fixed an issue with the Pee Drinking interaction missing its text
- Updated various settings so you can choose various different types of Sims that can do that one setting/action, instead of having a ton of settings for each Sim type.
- Added a setting to toggle the sex notifications when sex starts for various Sims
- Moved the relationship requirements for Lure Rape and Fight Rape into python and out of the tunings
- Removed many checks for arousal and relationship to the python code itself
- Added a setting for toggling the romance requirement for multi sim normal sex
- Added a setting for toggling the relationship requirements for Lure Rape
- Added a setting to toggle the high arousal distress interactions
- Added a setting to toggle the traumatized buff after rape.
- Added a setting for toggling the Arousal debuffs
- Added a setting to toggle auto apply of tears during rape
- Added settings to toggle auto apply of Cum and Milk overlays during Breast Milking, Breastfeeding, Cum Eating, and Penis Milking
- Added settings for chance of pregnancy via anus and mouth
- Added a setting for toggling the Cum On Self Choose Cum Location dialog
- Added a setting to toggle self impregnation
- Added the ability to choose the currently playing animation to continue playing in the new location
- Fixed an issue with disabled animations still being chosen when starting an animation, when advancing an animation, and when changing animations
- Added the ability to choose animations by author
- Added Oral and Anal inflation.
- Fixed an issue when initializing body parts for Sims with an occult that have their gender options changed via Custom Gender Settings (or any other means for that matter)
- Updated the Autonomous Multi/Solo Sim Pee Drinking and Autonomous Multi/Solo Sim Poo Eating settings to use the new system for settings, where you pick types of Sims.
- Updated the Autonomous Multi/Solo Sim Breastfeeding, Breast Milking, Cum Eating, and Penis Milking settings to use the new system for settings, where you pick types of Sims.
- Added support for when you change breast, belly, pregnant shape, and testicle size using Custom Slider Framework that will automatically set your choice as the original size swelling will revert to.
- Under each pie category Enthuse, Complain, Think ABout Positive/Negative, there are now four more categories that organize the fetish interactions a bit more Giving, Receiving, Seeing Giving, and Seeing Receiving
- Sims will now only autonomously be allowed to do a fetish interaction if they have a fetish for that fetish+action
- Sims will no longer be allowed to Complain about a fetish+action they actually Like and vice verse for Enthuse and Dislike
- Added settings to randomize fetishes on Sims when they spawn or to manually randomize fetishes for all Sims
- Added a setting to hide the vanilla Woohoo and Try For Baby interactions
- The pregnancy notification will now appear even if a Sim does not pass the dice roll to keep the air of mystery.
- Self targeting actions added to animations without them, will no longer automatically take the animation category from the animation, but will instead be classified as TEASING, and thus won't be applying cum to places that don't make much sense on the body. Again, only if the animation does not specify self interactions!
- Added an inflation meter for Stomach Inflation

Version 3.8:
- Unlocked Teen Sim to Adult Sim Romance
- Renamed Pet in the pet settings to Animal
- Renamed Assault to Rape
- Separated the Sex settings and Sim Data and Milk Farm settings and Sim Data into their own data files within mod_data
  - With this change all Sims that had milk/cum levels will be reset to zero
  - Also with this change if a Sim had swelled Breasts/Testicle sizes, you need to go into the CSF menu and reset their Breasts/Testicle back to normal!
- Removed the old Want Level System
- Cleaned up the Start Sexy Time dialog, now you can choose any Sim combination you want.
- Fixed Intervene and Jealousy not properly queuing the after sex stop interaction to fight/slap
- Fixed a bug with encounters where choosing no would still start sex if the Sims were close enough to the location
- Fixed a bug with encounters where they were teleporting to the sex location after accepting sex.
- Bumped the maximum "switch to climax on orgasm percentage" to 101 to allow disabling it.
- Fixed an issue when assigning Sims to actor slots where Animal Sims could take Human slots and vice verse
- When manually running the Rape interaction on a Sim with romance or friendship above 30, the error about "Things not working properly" should no longer occur
- Renamed Poo On and Pee On to Offer Poo and Offer Pee
- Renamed Get Pooed On and Get Peed On to Eat Poo and Drink Pee
- Rapist Sims will no longer Intervene rape that they see. Nor will they be angry when witnessing it.
- Sims will now stand up or stay standing when trying to fight an aggressor in a Rape Intervene.
- Sims will now stand up or stay standing when trying to slap a Sim they are jealous at.
- Fixed Jealousy, it should now activate properly when Sims want to be jealous.
- Prevent Sims from being asked for sex if they are trying to intervene a rape in progress.
- Changed the swelling code to use buffs to apply/remove slider values
- Fixed the scaling on swelling if a slider is not at its default when calculating how much the body location should swell
- Mobile Milking uses buffs to apply the mobile milking apparatuses, so it will now apply on every outfit. (Breaks on mermaids in the tub though!)
- Overlays are now applied via Buffs, making them less liable to cause outfit issues or to become "stuck"
- Nude parts are now applied via Buffs, so if you unequip a nude part for a Sim, it stays unequipped, even when they change outfits. (Reequip the part to cancel the effect)
- Added a notification when a Sim is having an orgasm that tells the player the Cum Levels of their Sim is too low for an orgasm.
- Fixed an issue with Animation Customization when applying customized animation actor actions
- Renamed Modify Applied Overlays to Modify Overlays
- Removed the check preventing usage of Start Sexy Time while the active Sim is engaged in sex.
- The Be Aroused Positive buff should no longer stick around.
- The Witness Rape buff will no longer apply when Sims are not actually being raped.
- Fixed Join or Masturbate autonomy, before when a Sim fails to join but tries to Masturbate, their Arousal was being reset to 0% rather than 100% and they were not actually trying to masturbate.
- Join autonomy now only requires 60% Arousal instead of 87%.
- When Sims decide whether they want to join or not, they will now be checked to see if they are ALLOWED to join too.
- When a Sim asks to join, they will do a proper animation for it.
- Fixed an issue when buying Supplements, the bought items will now actually be purchased and delivered (To the inventory). (Sims 4 devs sneakily removed the mailman purchase code!)
- Fixed an issue where Sims trying to join could freeze in place if they are not allowed on the lot the sex they are being invited to, is happening.
- When starting sex, Climax animations will now be excluded
- When Sims walk to a sex location, but there are no animations found, the player will be informed about that.
- When asking a Sim to join by clicking on them, they will now be auto selected in the selection dialog.
- When cleaning overlays, only Cum, Scat, Tears, Milk, and Urine overlays will be cleaned off. Blush and Bruises will no longer be cleared.
- Added Base Game "Blush" as overlays for Blushing.
- Added the Batuu Alien Heads to the Heads Body Part Selector
- Prevent Wicked Whims from interfering with the nudity of Sims engaged in DD Sex.
- Added a dialog when a Sim that produces Cum is about to have an orgasm that will prompt the player where they want the Cum to go.
  - This selection will be remembered until the end of sex or when you manually choose a different option Click -> DD -> Preferred Cum Location
- Added settings for toggling the Pregnancy Notifications for Player and Non-Player Sims separately.
- Fixed an issue with CAS Parts that allowed for a None selection where the Default selection was both None and Use Global Settings.
- Added settings that when enabled will let you unequip all equipment no matter what animation is playing.
- Added settings for toggling Autonomy for Multi Sim Normal Sex, Rape, and Rough Sex
- Added settings for toggling Autonomy for Solo Normal Sex
- Added settings for toggling Arousal as a requirement for Normal Sex, Rape, and Rough Sex
- Added settings for toggling Arousal as a requirement for Solo Normal Sex
- Sims need to have a preference for the gender of the Sim they are asking for sex from or trying to rape.
- Fixed an error where position offsets were not properly being utilized when positioning Sims in Sex.
- Updated Knotting, it is now more stable than ever.
- When Sims have locked motives, those locked motives will no longer be dropped by DD during sex.
- When Sims have an orgasm in the Anus of a Sim that does not have a Vagina, then they will have a chance of becoming pregnant. If the Sim to become pregnant can actually become pregnant.
- Updated the Club Interactions for Normal Sex, Rape, and Rough Sex. They should properly work as intended now.
- New icons for various interactions. So you may be able to tell what interaction a Sim is performing when they are having "sex".
- Devious Desires requires at least version 1.75 of Sims 4 Community Library

Version 3.7:
- Fixed an error when changing Zones while Sims are having sex.
- Added Rape interactions
- Fixed an issue where many animations were flagged as DISALLOWED_FOR_RANDOM, because their snippets did not contain the flag to specify whether they are allowed or not.
- When Sims look for places to have sex at while not on their home lot, Rented Zones will be considered as "owned" and Sims will be allowed to have sex anywhere on Rented lots.
- Slaves may have sex anywhere, even if their owners do not own the current lot.
- Reduced the lag by preventing Sims from even attempting to do the Masturbation/Have Sex interactions when they are not even aroused, full of milk, etc.
- Added a setting to toggle Autonomous Masturbation on/off
- Added a setting to toggle Autonomous Self Milking on/off
- Added a cooldown between when Sims attempt to ask for sex
- Removed many unused settings and code
- Sims should no longer be aroused a heck of alot when Sims have sex nearby
- Improved the performance when clicking on Sims
- Encounters now use the same tags as Animations for both Encounter Tags (Animation Tags now) and Encounter Sim Tags (Animation Actor Tags now)
- Start Sexy Time will now teleport the Sims instead of waiting for them to ask each other for sex (It IS a cheat interaction after all)
- Fixed a couple issues with autonomy when Sims try to start sex.
- Fixed the notification when Sims are having sex, so it doesn't just say Sex all the time.
- Fixed an issue where Pet Sims were able to rape Human Sims due to an oversight in the test
- Cleaned up the false advertisements, Sims should request the Milk, Cum, Scat, and Watersports more often if their Needs will be satisfied by such requests
- Fixed the misalignment of the upper body of Sims when they start to have sex.
- Patch a hole in the autonomy check where it was not checking friendship levels between Sims for Rape.
- Fixed an issue when Animals try to rape Animals where it would say there is a problem, but there really isn't
- Autonomous Breastfeeding, Breast Milking, Cum Eating, and Penis Milking no longer require arousal
- Start Sexy Time will no longer appear when clicking on Sims.
- Improved the performance of DD: The longer you play on a lot, the less lag you will receive when Sims try to masturbate or have sex (Because objects that do not have any animations available will no longer be chosen).
- Completely removed the "animation_allowed_for_random" and have switched to using the DISALLOWED_FOR_RANDOM tag entirely.
- Added solo Scat, Watersports, Breastfeeding, and Cum Eating interactions
- Added the "MOLESTATION" animation tag and the "BEING_MOLESTED" and "IS_MOLESTING" tags.
- Fixed an issue when using the top level animation operations where it would not properly apply the actor tags when saving the game.
- Split the Milking tag into the Breast Milking and Penis Milking tags.
- Fixed a few potential errors when modifying customizations where it would output NONE values
- If an animation requires a Vagina, the actors bottoms will be properly removed now
- Sims will stop feeding if their hunger is satisfied or the other Sim runs out of milk/cum.
- Sims will stop Scat/Watersports if their hunger is satisfied or theother Sim has a satisfied bladder/bowels
- Hooked up the Always Accept for Rape, Rough Sex, and Normal Sex settings with their respective interactions.
- Added settings to toggle autonomy for Scat and Watersports
- Added settings to control solo and all autonomy for Breast Milking, Breastfeeding, Cum Eating, and Penis Milking
- Added a setting to set the maximum size the Breasts and Testicles can swell.
- Added a cooldown for autonomous solo sex so you don't get spammed with interactions being queued.
- Added a better cooldown System for asking for sex that will have Sims go on cooldown only for the Sim they asked
- Improved the performance when clicking on objects, no longer do we need to check if the clicked on object has animations, instead this is done before even registering the interaction
- Fixed a bug when trying to join sex of a target Sim
- Renamed Scat and Watersports to Poo Eating and Pee Drinking
- Hooked up encounters to the new sex interactions.
- Sims now "reserve" the objects they are having sex on. This prevents other Sims from trying to start sex there or to use the objects.
- Fixed actor assignments at the start of sex, it is now much much more accurate when assigning Sims to each actor slot of an animation. (Assuming the animation is properly tagged of course!)

Version 3.6:
- Fixed an issue where Small Dogs were not allowed to do anything DD related!

Version 3.5:
- Reworked the Have Sex interactions to mostly be dynamically generated.
- Reworked the Have Breasts Milked and Have Penis Milked interactions to mostly be dynamically generated.
- Added interactions to Have Rough Sex As Dom and Have Rough Sex As Sub. (with autonomy)
- Added interactions to Offer to Milk the Breasts/Penis of another Sim. (with autonomy)
- Added interactions for Scat and Watersports (with autonomy)
- Added interactions for Breastfeeding and Cum Eating (with autonomy)
- Fixed an issue when searching for Breastfeeding, Cum Eating, Scat, and Watersports animations.
- Animations not allowed for random should now be properly filtered out when searching for animations.
- Add the `MOTHER_PLANT` animation tag.
- Added command `dd.cleanse_the_horny` to remove all the horny from Sims currently spawned.
- When Sims need to masturbate or have sex while they are not on their Home Lot, they will now choose to masturbate/have sex at Toilets and Showers instead of wherever they want.
  - Slave Sims from Sim Snatcher will be allowed to have sex/masturbate anywhere on lots owned by the household that owns them.
  - Sims that love Exhibitionism or Public Sex will be allowed to have sex/masturbate anywhere on lots
- If a Sim fails to route to a Sex location, they will now be teleported instantly, instead of having to see them fail to route 10+ times.
- Fixed some of the misalignment of Sims at the start of sex.
- The romance interactions between Sim and Pet no longer require a Sim to be a zoophiliac (Though autonomy for doing these still requires the Sim to be a Zoophiliac)
- Reworked the "Change * Available To Be Assaulted/To Assault" settings, they are a bit cleaner now. (and they include Foxes!)
  - These settings are now factored properly into the Start Sexy Time dialog and will filter out Sims that fail this criteria.

Version 3.4:
- Fix a minor issue when converting animations where the animation tags are not being set properly
- Fixed tags not being properly used when querying animations.

Version 3.3:
- Fixed an error that would occur when opening the Animation Customization dialog.

Version 3.2:
- Masturbate Here will now only appear in places with animations
- Added Milk My Breasts Here interactions when clicking on Objects, Terrain, or your own Sim.
  - These interactions can be done autonomously as well!
- Added Milk My Penis Here interactions when clicking on Objects, Terrain, or your own Sim.
  - These interactions can be done autonomously as well!
- Added interactions to Ask other Sims to Milk My Breasts.
  - These interactions can be done autonomously as well!
- Added interactions to Ask other Sims to Milk My Penis.
  - These interactions can be done autonomously as well!
- Renamed Sexual Need: % to Arousal: %
- When choosing custom CAS Parts in the Body Part and Equipment Part dialogs, the target Sim will appear in CAS now, instead of a lifeless mannequin. You may also now choose many new CAS Part Types you could not choose before (Such as Skin Details and Piercings)
  - With this change, Custom CAS Parts may now be chosen for Animal Sims as well!
- Fixed an issue where you could select NONE for sexual organs
- Fixed an error that could occur when Sims autonomously try to have sex or be milked
- The animations/cas part/encounters loaded notification will now show how many total animations/cas part/encounters were found.
- Fixed a few animation customization issues in "animation_customizations/main.json" for customized SCAT and WATERSPORTS animations, where their actors were not tagged for SCAT_GIVER/SCAT_RECEIVER or WATERSPORTS_GIVER/WATERSPORTS_RECEIVER.
- You no longer have to unequip the previously chosen custom CAS Part in order to select a new one.
- After choosing Custom CAS Parts, a new dialog will prompt you to choose the correct CAS Parts from the list as well as the Main CAS Part.
- Fixed an issue when coming back from choosing a Custom CAS Part where the household is nullified on the Sim the dialog was open for.
- Added `BUNK_BED` to the list of animation locations.
- Added `IS_WATCHING_PORN` to the list of animation actor tags.
- Added `MIND_CONTROL` to the list of animation tags.
- Added `BEING_MIND_CONTROLLED` to the list of animation actor tags.
- Fixed an issue where newly created Animal Sims were not equipping their bits on Zone Load.
- Moved the Anal, Cock, and Oral Vore strings to the DD Kinky package
- Customized a Penis Milking animation to main.json for a Dining Chair (It is an Alonely animation) Adult Human PEN + Adult Human Any
- Cleaned up the Ask To Milk My Breasts
- Changed NONE when selecting Sexual Organs for an actor in Animation Customization to ANY
- NONE will now be selected when no unequip types are selected
- ANY will now be selected when no Sexual Organs are selected
- Moved the Milking interactions under a Milking Pie Menu (Only seen if Sims can be milked in two different ways)
- Fixed an error where the valid CAS Part count was not correct
- When loading CAS Parts, AURBURN is now changed to AUBURN
- When loading Animations, DINING_TABLE is converted to DINING_TABLE_LONG
- Renamed Penis Milk to Cum
- Renamed Penisfeeding to Cum Eating
- Many of the dialogues when customizing and when choosing animations are now sorted alphabetically.
- Major clean up of the Animation Query System, CAS Part Query System, and Encounter Query System, with some minor performance improvements along the way. (Absolutely let me know if there are any issues!)
- Renamed the gendered Animation Locations to non-gendered ones. i.e. `COW_MALE` and `COW_FEMALE` become just `COW`, `CHICKEN_MALE` and `CHICKEN_FEMALE` become just `CHICKEN`, etc.
- The Full Body Body Part will no longer be selectable by Human Sims, it was way too glitchy for its own good.
- Reduced the delay for interactions to appear when clicking on Sims.
- Reduced the initial value of Arousal, so instead of Sims starting at 50%, they will start closer to 25%
- Removed the None Option from the Full Body Body Part.
- Devious Desires requires at least version 1.74 of S4CL

Version 3.1:
- Improved the performance when Sims are searching for objects to masturbate on.
- Added a "Have Sex" interaction on objects and on Sims.
  - These interactions can be done manually and autonomously by Human Sim x Human Sim, Human Sim x Pet Sim, Pet Sim x Human Sim, Human Sim x Fox Sim, Fox Sim x Human Sim, and Pet Sim x Pet Sim.
  - Autonomy is based on the Sex Life motive and romance relation.
  - Integrated the Have Sex interactions with the game in a much more seamless way. Many of the romantic buffs and traits can have an effect on the Have Sex interaction now.
  - When Sims get to the sex location, sex is no longer immediately started, but DD will wait for the other Sims to get there before starting the animation.
- Sim Snatcher should no longer try to bother Slave Sims that are trying to Have Sex or Masturbate
- Fixed the TOP and BOTTOM tags not properly being added in the Animation Customization dialog
- Foxes now have a Romance track for Human Sim to Fox Sim.
- Added a fox rig with penis bones to the DD Pets package.
- The "_main_bulk_customized_animations.json" is no longer a required file to be installed. In case you do not like the customizations made within it. ("main.json" will continue to be required!)
- Fixed an issue with "Start Sexy Time" where Sims with a high incest fetish were not appearing for selection when the two Sims are blood related.
- The "Start Sexy Time" interaction has been moved to the SHIFT+CLICK menu.
- Potentially fixed some misalignment when Sims go to have sex.
- Potentially fixed issues with DD locating objects that don't have a location when starting sex by clicking on Sims.
- Prevent masturbate here on objects from activating when a Sim does not need sex
- Add error handling when initializing selected CAS Parts for Sims that will log more details upon setting their current outfit.
- The Sex Life motive debuffs no longer have a value assigned to them, they are more like an indicator instead.
- The deviousdesires_wickedwhims_loader.config file will now be auto created after loading into a household.
- Clarified the install check dialog a little bit so that it displays a mod name for missing files rather than just the confusing file names.
- Added a deviousdesires.config file (Which is auto created after loading into a household for the first time), this file will allow enabling of warnings when reading animation or CAS Part snippets.
- The Masturbate interaction will now check if a Sim is engaged in sex or not and prevent them from performing the interaction if they are.
- Fixed some issues that caused errors when Sims somehow don't have any outfits
- Fixed an issue when checking if can show trait interaction
- Oral, Anal, and Cock Vore fetishes have been moved to DD Kinky
- Utilize the new Gender Options available in 1.73 of S4CL for Animal Sims.
- Devious Desires now requires at least version 1.73 of S4CL.

Version 3.0:
- An entire overhaul of the Nudity System
- Many bugs that previously existed no longer exist with this overhaul
- Short list of Nudity changes:
  - Select custom CAS Parts for every body location
    - When selecting Custom CAS Parts, you may choose them in CAS!
  - More selectable body parts and equipment (Head, Tail, Ears, Mouth, Feet, Hands, Underwear, pubic hair, skin overlays)
    - Parts like Head, Tail, Ears, Mouth, Feet, and Hands will apply to Sims even when they switch to their nude outfit (Assuming a part does not already take the matching slot on that outfit).
    - This means that you could have a full time anthropomorphic Sim if you really wanted! or you could even use the "Heads" from the Star Wars DLCs as your dedicated Head.
      - All Heads take the Hat slot, make sure not to wear a hat on the outfits you want the head to appear on
    - To select a custom part that is not equipped to the expected body location, make sure it is the only part you select and DD should be able to find it!
  - Unequip/Equip ALL body locations (Piercings, Leggings, Tails, Ears, Eyes, Eyebrows, etc.)
  - Skin overlays will auto apply, no more black penises! (currently only Noir skin overlays with Noir penises) Will not currently apply to the NATIVE part!
  - Select default body parts and equipment that will apply to Sims that do not have selections. No more having to select different parts per Sim. (Choose between Native, Random, and Custom!)
  - Each body part can have its own selection!
  - Select body parts for each of your Sims occult types separately!
    - Your Alien Sim can have a small penis selected while they are in disguise form, but a massive honking dick when in Alien form if you wanted. (Same with all occults)
  - If a Sim is wearing their Bathing outfit, they will not be able to Equip/Unequip equipment. At least until they stop wearing their bathing outfit.
- S4CM Outfit integration
  - Nudity Interactions of DD will appear under the Outfits pie category in S4CM.
- Fetish interactions no longer clog up the recommended interactions when clicking on Sims.
- Added many new Animation and Animation Actor tags.
  - Added an animation actor tag that PREVENT_ORGASM_INCREASE (and it works)
- Updated the LODs for the dicktator bottles, they will no longer look weird when looked at from a distance. (They still look weird in the inventory)
- Cleaned up the install check, it should be more clear now.
- Added command for refreshing all Sims selected CAS Parts `dd.refresh_all_sim_body_and_equipment_data`, useful after selecting new default parts and you want to update all Sims with it.
- Short list of Sex changes:
  - Added Masturbation interactions both manually and autonomously done. Sims can now fulfill their sexual need without requiring other Sims to accept sex with them!
    - Sims should put down whatever they are carrying before they try to masturbate.
- Added Fox support in many places.
- Foxes should in theory be able to start sex, more testing is needed though.
- Foxes can use animations that were made for Small Dogs
- Devious Desires will now completely ignore the ALL unequip type, since it is too generic and too widely abused by animation authors. A setting was added within DD Settings -> Global Settings -> Cheats that may be used to reenable this functionality
- Devious Desires now requires at least version 1.72 of S4CL
- Devious Desires now requires Noir's Pornstar Cocks to be installed at all times!


Version 2.14:
- All DD supplied overlays now appear in CAS and may be removed/applied from there.
- Fixed an error when reading wicked whims tunings.
- Removed the child age from appearing for selection within the DD club activies
- Added a By Tag option to the category menu when choosing animations.
- When a Sim changes their outfit, the check that ensures nude parts are correct now only applies outfit changes if the outfit was modified by it.
  - This should maybe fix the infinite switching of outfits over and over again.
- Sorted the string tables of DD Kinky and DD Pets by alphabet
- Reduced the amount of Wiener.
- Added a Realign Actors interaction. SHIFT+CLICK Sim in Sex -> DD -> Realign Actors
  - Use this interaction to realign Sims that are going awol and floating off to who knows where. (Or they are off by just a little bit)
- Devious Desires now requires at least version 1.67 of Sims 4 Community Library!

Version 2.13:
- Add encounter sim tags for breasts being milked, penis being milked, watersports, and scat
- Fixed an issue where the milk produced by Sims wasn't being owned by the Sim receiving it.
- The Complain, Enthuse, and Think about interactions should now be available for Scat and Watersports
- Overrode a few things in S4CM to allow for things like Teen Pregnancy/Romance, as well as Pet/Human hybrids

Version 2.12:
- Fixed an issue where a Sim that has swollen parts due to milk levels would stop scaling those parts, even if they are milked.
- Fixed an issue where Sims would lose either their top or their bottom body parts.
- Added Encounters
  - When a Sim asks the Active Sim for sex, an Encounter may occur instead of the Ask For Sex interaction.
  - Accept the encounter to start sex.
  - Decline the encounter to cancel sex.
  - Default encounters are available for Pet x Human, Pet x Pet, and Human x Human for Normal Sex, Rough Sex, and Assault.
- Fix an issue where Sims would sometimes have missing body parts.
- Fixed an issue where Sims would sometimes wear their outfits in the shower.
- If a Sim is incestuous (High Incest fetish or global incest setting is enabled), they will now be able to use romance interactions on family members.
- When a Sim is routing to sex and the interaction is cancelled, they should no longer teleport to where they were going.
- Fixed an error where Servos were not properly locating suitable body parts.
- Fixed an error where Mermaids in mermaid form were not properly locating suitable body parts.
- Added a proper acknowledge dialog when no equipment is found for a Sim.
- Animation Customizations
  - Fixed an issue where Animation Customizations were not updating the json files with changes.
  - Added a Select By Category option within the Animation Customization dialog
  - Fixed a couple issues with Bulk Customize where it would lag a bunch before appearing.
  - The Penisfeeding and Breastfeeding Bulk Customize operations will now work on Solo animations.
  - Added a default `_main_bulk_customized_animations.json` file that contains bulk customized animations. They may not be entirely accurate but at least most animations will have at least some proper tags for Penisfeeding and Top/Bottom
  - Fixed an error where the "my_own_customizations.json" file would not contain any new customizations if the file did not exist when the game loaded.
  - Split the BEING_MILKED actor tag into BREASTS_BEING_MILKED and PENIS_BEING_MILKED
- Created the Devious Desires Dirty Play package and ways to both start it and tag animations for it:
  - Added both Watersports and Scat (Start them via the Start Sexy Time)
  - No animations were made for them, but at least one animation by fouyaya (scat) and Yrsa (watersports) were customized for the Floor!
- Added Milking for Breasts and Penis via Animations (Click -> Start Sexy Time -> Ask To Milk Breasts/Penis)
  - The Sim that initiates the interaction will be the one that receives the milk.
- Breast Milk and Penis Milk can now be used to fill Vampiric Thirst
- Added the ability for Sims to select themselves when using the Convince to interactions.
- Fixed an issue with the Random button that was not properly locating animations.
- Devious Desires now requires at least version 1.63 of S4CL

Version 2.11:
- Added the bulk operation for tagging animations as Penisfeeding to the bulk operations list.
- Sims that do not produce Breast or Penis milk will still be able to milk themselves until they run out.
  - This is to allow the Breasts/Testicles of these Sims to unswell as well as to allow you to get every drop out of them.
- The Fetish interactions (Enthuse, Complain, Think About) should longer appear during sex.
- Included a Red Shirt, Red Flip Flops, and Denim Pants
- Updated Milk Farm on tick so that a Sim can scale properly when they no longer produce milk.
- Fixed an error that could occur when restarting sex instances.
- Fixed a sync issue when Sims start sex where the two Sims will be playing their animations out of sync.
- Fixed an error with one of the sexual organ tests if the DD Settings were set a certain way.
- prop_name should now properly be added to snippets when converting them from WW to DD
- The prop_name is no longer required, though adding it to your snippets is still helpful to you!
- Added an installation check that will do the following:
  - Check for duplicate files
  - Check for missing required files
  - Check for old files (Such as the DDWWIntegration file)
  - Check for installed third party body parts for Human Sims.
- Fixed an issue where the Robot penis from Wicked Whims was available for Human Sims to randomly select.
- Fixed Sims teleporting to sex locations if sex is declined or if sex fails to start.
- Sims should no longer be assigned new random parts on load.
- When a Sim with a Penis reaches 85% on their Orgasm meter while involved in sex, sex will immediately switch to a Climax animation (If available).
  - Sims with a Vagina having an orgasm are unchanged.
- Locations will now properly be found when Sims are looking for places to perform Breastfeeding, Penisfeeding, etc.
- If custom body parts are installed, they will be available for selection randomly instead of being ignored.
- Fixed Sims equipping clown outfits (random outfits) when undressing.
- Added an interaction to resync Sims if they happened to become unsynced (SHIFT+CLICK Sim -> DD -> Sync Animations)
- Fix some issues with Animation Synchronization (Where Sims would be out of sync with each other during sex)
- Unequipping Full Body will now properly equip Top and Bottom body parts.

Version 2.10:
- Updated Routing to sex location to be more fluid.
- Fixed an issue where Sims would not properly initiate a Join Sex interaction.
- Fixed some cases where Sims were not properly routing to sex locations.
- When Sims end sex, they should in theory no longer spawn inside of the objects they are having sex in.
- Added a Sex motive
  - In order to see if your Sex motive needs to be fulfilled, CLICK on Sim -> Info -> Sexual Need: %
  - Watching romantic movies will increase the rate at which a Sim needs Sex.
  - Every flirty buff a Sim gets will increase the rate at which a Sim needs Sex by about 10%
  - Every Angry, Sad, Embarrassed, Stressed, or Uncomfortable buff a Sim gets will decrease the rate at which a Sim needs Sex by about 10%
  - A Sim will absolutely need sex after around 3 Sim days of going without it.
- Moved the Orgasm Meter to be under the Information Pie Menu. CLICK on Sim -> Info -> Orgasm: %
  - Changed the Orgasm Meter text to simply be "Orgasm: %" instead of "Orgasm Meter: %".
- Added Milk Level meters for Breasts and Penis (Under Info)
- Added Inflation Level meter for Vagina (Under Info)
- Animation Customization
  - Added a bunch of Teasing animations to the main.json
  - When customizing current animation, the actors assigned to each actor slot will now display next to the actor id
  - Added the ability to modify actor self interactions in the animation customization dialog
  - Added the ability to modify Unequip Types for actors.
  - Added the ability to modify the Sim Type of actors in Anim Customization
  - Added a bunch of new animation tags and animation actor tags (Including some tags that will be used in the future for modifying skill levels and motives)
  - If an animation does not come with an action, it will now be supplied with a default one.
  - Added Bulk Operations
    - These bulk operations can be applied to all animations, all animations of an author, or to individual animations.
    - See the wiki for more details!
- Added Actor Self Interactions (This allows for cum on self and self impregnation, etc.)
- Fixed an error where the StatisticCategory Scared_Buffs did not exist for those who did not have the DLC installed.
- Added new overlay types, URINE, SCAT, BRUISES
- Added new overlay body locations, INNER_THIGH, LEFT_INNER_THIGH, RIGHT_INNER_THIGH, OUTER_THIGH, LEFT_OUTER_THIGH, and RIGHT_OUTER_THIGH
- Fixed an issue where Sims were not able to start or join sex autonomously.
- Fixed issues when loading a few animations that were made for WW.
- Proximity arousal
  - Sims that approach Sex that is taking place may become aroused.
  - Sims may also be disgusted, if one of their NOT ENJOYED fetishes is happening within the sex interaction (Such as a Sim that dislikes Zoophilia)
  - Once the Sim is "Aroused" and they have a Sexual Need below -50 (About 75%), they may ask if they can join (Assuming autonomous join is enabled AND they are willing to join) or they may go off and masturbate somewhere.
  - If you decline their proposal to join, then they will go off and masturbate somewhere.
- Fixed an issue with fetish enjoyment level detection, if a Sim was at level -100, they would only be considered to Hate It, they would not be considered for the lesser "hate" levels, such as Not Enjoy, Not Okay, etc.
  - This led to some oddities where a Sim that hates a fetish wasn't being properly checked for Not Enjoying that fetish, which led to DD thinking they Enjoyed It instead!
- When choosing an animation for Solo Sims, Sims with a Vagina should no longer be able to pick animations requiring a Penis and Sims with a Penis should no longer be able to pick animations requiring a Vagina.
  - Added a setting that may be enabled for those who still want this option.
- Renamed GIVER and RECEIVER to TOP and BOTTOM in various places to make it more obvious what they represent.
- Removed pagination from the animations list (Up to 20k animations at least before pagination will begin again)
- Fixed an error where props and objects were not properly being animated

Version 2.9:
- Fixed an error when Sims get erect or flaccid.

Version 2.8:
- When first loading the game, the outfit a Sim is wearing will be properly recognized when they attempt to undress
- Overhauled how nudity works and streamlined the nudity system a bit.
- Added the ability to unequip full body outfits separately from other clothing parts
- Added Equip interactions under the Equipment Pie category
- Moved the Unequip interactions under their own Unequip pie category within Equipment
- Added a few more things you may unequip (Wrists, Necklace, etc.)
- Prevent Sims from getting stuck doing the Wait For Everyone interaction
- Possible fix for Sims generating a random outfit when they become naked.
- The default WW body parts are now available for selection in the DD Equipment Selector.
- Fixed Sim positions being moved as a sex animation starts
- Fixed an issue where the overlay menu would not open if an overlay did not have a raw display name specified.
- Fixed an issue where Sims would equip random clothing pieces when they undress


Version 2.7:
- Update the Hard Penis testicle slider name to match the new one from CSF version 1.9

Version 2.6:
- Sims can now become jealous when they see their lovers having sex with other Sims
- Removed the Over-Supplemented buff when taking Supplements so they always succeed now.
- Added new text when Sims discuss the Domination fetish
- Added an Enable Jealousy setting
- Added an Enable Intervene setting
- Added a setting to Disable Motives Decay during sex
- Added Cuckold/Cuckqueen, Cuckold Bull/Cuckcake, and Cuckold Spouse fetishes
- Scat and Watersports have been split into their own fetih category and will now only appear later on when DD Dirty Play is implemented.
- Added the ability for other Sims to intervene when a Sim is being assaulted by another Sim, if they like the Sim be assaulted of course. (It also comes with amazing new buffs!)
- Added a setting to disable the Fetish Change interactions. (Global Settings -> Cheat Settings -> Enable Fetish Change Interactions)
- Added the ability to start any of the Sexy Time features with multiple Sims.
  - The mod will choose only one of the chosen Sims for the Ask For Sex interaction though!
- Pet Sims should not longer be available for sex if sex is disabled in the DD Pets settings
- Sims should now drop their yogurt before getting it on.
- Reworked how CAS Parts are loaded and organized to be more performant. This should decrease load times even further.
- Sims should by default not select the Native CAS Part for the hard penis if other CAS Parts are available. This should help to alleviate the issue where a Sim "doesn't have" a hard penis selected initially.
- Pet Sims can now take off their clothing.
- When becoming naked, accessories should be taken off of Sims now.
- Sim and Object data are now stored separately from settings.
- Settings are now global, meaning they apply across all Saves.
- Pets should no longer equip a collar when getting naked.
- When a Sim undresses any of their clothing, they will create a clothing pile.
  - This will only occur if you have the Laundry Day DLC and if you have any of the Laundry furniture items in the house.
- The interactions for undressing will be disabled, if the Sim has already undressed those clothing items.
- Fixed many issues with nudity and how it is handled.
- Raised the default Want To Assault threshold from 200 to 300.
- If the game is loaded and a Sim isn't in their everyday outfit, the mod will account for this when taking off their clothing
- Added a setting to toggle laundry creation
- Removed the Enable Call Threading and Enable Sex Call Threading settings
- Removed General Settings
- Changed the verbage of the Incest override setting to be more clear as to its intent.

Version 2.5:
- Animations that were customized before the identifier change should now be loaded once again. Old animation customization files will be relevant again.
- When customizing an animation using the Customize Current Animation interaction, animations should be reloaded properly.
- Split up the Accept Sex Threshold, Accept Rough Sex As Dom Threshold, Accept Rough Sex As Sub Threshold, and Attempt Assault Threshold into four different settings.
  - Human to Human
  - Human to Pet
  - Pet to Human
  - Pet to Pet
- Updated the Show Want Level to make it more obvious how to see the calculations behind the scenes.
- Split up the Always Accept setting into four settings:
  - Always Accept Normal Sex
  - Always Willing To Assault
  - Always Accept Rough Sex As Dom
  - Always Accept Rough Sex As Sub
- Prevent sex from advancing or stopping if the automatic sex progression setting is disabled.
- Fixed an issue with the Show Milk Levels interaction not actually showing milk levels
- Fixed a few settings not having the correct text.
- Fixed an error when looking at effects of animations.
- Fixed an error when attempting to spawn props during animations.
- Updated a few settings to show their default, current, minimum, and maximum values.
- Added new animations provided by MISSME
- Added new settings:
  - End Sex After Any Sim Has Orgasm
  - End Sex After All Sims Have At Least One Orgasm
  - Maximum Time For Sex
  - Maximum Time Per Animation In Sex
  - Orgasm Fill Rate
  - Allow Romance Level Increase After Sex
- Aggressor Sims should no longer gain romance relationship points after an assault.
- Sims should now have an even lower want to assault Sims they do not have a gender preference for (-5.0 dropped to -30.0)
- The overlay that applies to Sims that produce breast milk when they have an orgasm is now properly removed at the end of sex.
- Added fetishes
  - Not all available fetishes will be listed below!
  - Added the ability to Configure Fetish Enjoyment Levels within the DD Settings to be whatever you wish.
  - Sims can Enthuse about a fetish if they are at enjoyment level 50 and above for that fetish.
  - Various Enjoyment Levels (From -100 to 100):
    - 75.0 and above = They love it.
    - 50.0 and above = They like it.
    - 25.0 and above = They enjoy it.
    - 1.0 and above = They are okay with it.
    - 0.0 = They don't care about it. Neither into it or against it.
    - -1.0 and below = They are not okay with it.
    - -25 and below = They do not enjoy it.
    - -50 and below = They dislike it.
    - -75 and below = They hate it.
  - Added interaction to Enthuse About and Complain About Fetish to increase and decrease the Submission fetish level for your Sim and the other Sim.
    - Click on other Sim -> DD -> Enthuse About Fetish -> Fetish
    - Click on other Sim -> DD -> Complain About Fetish -> Fetish
  - Added interactions to Think About Fetish both positive and negative, which will increase or decrease the enjoyment level of the Sim that does it for a particular fetish.
    - Click on own Sim -> DD -> Think About Fetish (Positive/Negative) -> Fetish
  - The Enthuse About, Complain About, and Think About interactions are all autonomous.
  - Fetishes will only appear if their respective package is installed. i.e. The Zoophilia fetish won't appear if DD Pets is not installed.
  - Incest
    - The Incest fetish can be used in place of the global incest setting. Positive enjoyment will increase the want level, Negative enjoyment will decrease the want level.
    - Sims with zero for their Incest fetish level will have the -100000 value applied to their want levels as it has been.
  - Zoophilia
    - The Zoophilia fetish can be used in place of the Zoophiliac trait at level 50 and above for both fetishes.
    - The Zoophilia fetish + The Submission fetish can be used in place of the Pack Bitch trait at levels 50 and above for both fetishes.
  - Rape
    - The Rape fetish + The Domination fetish can be used in place of the Rapist trait at levels 50 and above for both fetishes.
    - The Rape fetish + The Submission fetish can be used in place of the Victim trait at levels 50 and above for both fetishes.
  - Domination
    - Factored into want levels for Rough Sex as Dom and Assault.
  - Submission
    - Factored into want levels for Rough Sex as Sub.
  - Many more fetishes that were not listed above were added!

Version 2.4:
- Fix some animation events not playing
- (Animation Mod Author specific change): Overhauled the animation event system. Events in the tuning files are now specific to the object/prop/actor they apply to.
- (Animation Mod Author specific change): Added Actor Equip CAS Part events for animations.
- (Animation Mod Author specific change): Added the ability to provide locations for your Animation by Game Tags.
- Added Milk Supplements: Dicktator and Lactator
  - Use supplements to boost your natural production of milk
  - Milk Supplements may be bought via the Buy Supplements interaction when clicking on a Computer.
- The Finished Loading Animations notification should now appear when loading into your household.
- Fixed animations not being loaded before the household loads in some instances.
- Fixed animations not being located properly when the setting to allow a Penis to take the Vagina slot or the setting to allow a Vagina to take the Penis slot is enabled.
- Breasts now vertically scale when they swell (or scale up) to look a bit more natural.
- Add a new Breast Milker
- Added a command to print animations belonging to a tag
- Fixed an error when an animation does not specify a joint name
- The convince to start sexy time methods no longer require the Autonomy settings to be enabled
- NPCs that are leaving the zone may now be selected when doing the start sexy time methods
- The hunger bar should now properly update when a Sim is Human
- When starting autonomous sex, assault, and rough sex, each individual setting for autonomy being enabled should be checked, rather than only checking the normal autonomy setting
- Fixed an issue where assault was not enabled for Sims due to the Pet/Human sex setting not being enabled.
- Devious Desires now requires at least version 1.60 of S4CL

Version 2.3:
- Reintroduced Knotting, but now it is better!
- Animations that are tagged as Aggressive/Rough should now appear for selection in Normal Sex.
  - These animations should also now appear when the setting to allow all animations for Assault/Rough sex is enabled.
- The Penis Erection Buff now only lasts 6 Sim hours
- Fixed an error when advancing sex animations after a knotting due to tags.
- Sex will not progress while a Sim is being knotted.
- Knotting now only happens for a limited amount of time. About 1 hour Sim time. After the buff expires, the animation will advance as normal.
- Knotting starts and ends during sex naturally.
- If a new animation is picked, the location changes, the player manually advances sex, or if sex is stopped completely, a Knotting will be considered as Pulled and the Sim will receive the negative Pulled Knot buff.
- Pets no longer lose hygiene during sex. Low hygiene was the reason they "turned black" or got darker
- The orgasm meter is now a top level interaction, so you can see it just by clicking on a Sim once.
- Allowed the ability to advance an animation, change location, etc, even while knotting. These will be considered as pulling the knot though!
- Fixed an error that occurs upon a Sim giving birth when DD Pets is not installed.
- Sims need a stored level of penis milk above or equal to the amount of penis milk lost in order to cause pregnancies, inflations, and apply Cum overlays.
- Added breast and testicle swelling.
  - Added swelling buffs
  - Utilize CSF sliders to visually show swelling (Only works with CSF installed!)
- Added Inflation
  - Utilize CSF sliders to visually show swelling (Only works with CSF installed!)
- Added a setting to reduce Penis Milk level when a Sim has an orgasm (Assuming they produce Penis Milk)
- Added a debug interaction to trigger an orgasm for a Sim during sex.
- Fixed Non-Cum overlays not being applied when a Sim has an orgasm.
- Sex will no longer attempt to apply overlays if Overlays are disabled in the settings.
- Total Breast Milk and Total Penis Milk increase per second may now be set as low as 0.01
- Added commands to set milk and inflation levels (ddmf.set_milk_level <body_location> <amount> [sim_id] and ddmf.set_inflation_level <body_location> <amount> [sim_id] sim_id is optional)
- Improved the performance when loading animations. They should now load much faster.
- Reduced the size and complexity of the WW addon ts4script file
- Fixed an issue where all animations would be getting selected and not just the selected animation
- Turn all load errors into warnings.
- Fixed the very long load time of animations.
- Fixed issues with Sim Types and Sexual Organs being wrong when loading animations.
- Update DDSimType to CommonSimType
- Removed CommonOccultType in favor of the one from S4CL
- Fixed an error when Penis Milk would increase upon a Sim having an orgasm when it should have decreased.
- Penis milk should now decrease properly instead of increasing when a Sim has an orgams.
- Split the breast milk producer and penis milk producer traits into a Basic and an Upgraded version.
  - The upgraded version is available from the Rewards Store.
  - If a Sim has a penis, they will receive the basic penis milk producer trait automatically.
  - If a Sim is or becomes pregnant, they will receive the basic breast milk producer trait automatically.
  - In order for inflation to occur, the inflating Sim must have the Penis Milk Producer Upgraded trait. The Basic trait will not cause an inflation.
  - In order for a Sim to swell, both testicles and breasts, they need the upgraded traits.
- DD now requires at least version 1.59 of S4CL

Version 2.2:
- Added the ability to customize animations by clicking on objects and the floor instead of just Sims
- Show Available Animations will now only appear on places Sims can actually route to, it will also only appear on places that have animations
- Fixed Sim Sex Role Preferences not persisting between save/load properly
- Added a command for manually reloading animations `dd.reload_animations`
- Added a command for manually reloading CAS parts `dd.reload_cas_parts`
- Fixed an error when creating knotting data
- Fixed an error where Overlays were not being applied properly.
- Added Adult Human Strap-on provided by Villianize
- The Mouth 3d Heavy Cum overlay model has been updated
- Overlays included with Devious Desires can now be translated.
- Animations and CAS Parts included with Devious Desires can now be translated.
- Penis State is now controlled via an Erection Buff instead of persisted data and a hidden statistic.
- Selected body parts should no longer clear on game load
- There is no longer a "Default" option in the equipment selector.
- Fixed an error where Penisfeeding would always be declined unless always accept was on.
- Added an Orgasm Meter "interaction" shown when clicking on a Sim while they are having sex.
- The No Location Found message is now available for translation
- Instead of displaying No Location Found or No Animations Available, the mod will now display when animations are still loading.
- Prevent DD autonomy from interfering with Sims engaged in WW sex.
- Giver and receiver animations are now filtered for again.
- Fix an issue when DD cock blocks WW during DD sex.
- The Orgasm Meter should appear as the first interaction now
- Combined the Start Milking Penis (Human/Pet) interactions into a single interaction
- Combined the Start Milking Penis (Human/Pet) interactions into a single interaction.
- Removed All Sims can take any actor slot setting (Simply enable both of the other settings for the same effect!)
- Removed the Manual NPC control setting. It was no longer being used anyways.
- If global incest is enabled, Sims will no longer receive a negative want level for being in a true family relationship.
- Removed sexual roles from being used when querying for animations.
- If Sims fail to be assigned to actor slots, instead of blowing up they'll be assigned to whatever slots are left available.
- Overlays and Pregnancies now occur based on whether or not a Sim is ready to climax
- Disable knotting stuff (It wasn't working anyways), until I can fix the errors with it.

Version 2.1:
- Removed the service sim check from want levels
- Renamed significant other to romantically involved
- The Finished Loading Animations and CAS Parts notifications should now display 0 instead of None when they do not load anything.
- Fixed Occult Sims not getting nude parts properly
- Added a setting so that Sims with a sex role preference will be able to select animations without sex preference tags.
- Fixed a slight bug when assigning actors

Version 2.0:
- DD General
  - Reduced the time to load into a household while using Devious Desires by a significant amount.
  - The code that loads the WW CAS Parts and Animations has been separated from the main Devious Desires script.
  - Overhauled sex completely.
    - With this overhaul, there were many bugs that were fixed.
    - With this overhaul, there are many features you may have been used with the old system that are no longer a thing, such as Plumbob hiding and phone silencing.
  **Animations**
  - Actor assignments now utilize Sexual Organs and a Sim Type rather than Animation Genders. This is much more flexible, because now you could potentially have a Sim with both a Vagina and a Penis. It also supports Male Sims with Breasts.
    - With this change it now means there is no concept of Gay, Bi, or Straight since Actors are simplified down to their sexual organs.
    - Added a new property to animation actor for specifying the preferred sexual organs, Penis, Vagina, or Breasts.
    - Added Pet Occult Sim Types (Vampire, Alien, Mermaid, Witch, and Robot)
  - Added Animation Tag: TENTACLES
    - Renamed Animation Tags:
    - LAYING -> LYING_DOWN
    - DOGGY -> DOGGY_STYLE
  - Added Actor Tags: INTOXICATED, DEAD, UNCONSCIOUS, SLEEPING, RESTRAINED
  - WW should no longer interfere with Sims that are engaged in DD sex.
  **Interactions**
  - Sex is now started via a single interaction called Start Sexy Time
    - To start solo sex, simply select your own Sim.
  - Removed the Start Solo Sex and Start Sex With Human interactions.
  - Swap Positions no longer cares about which sexual organs Sims may want to swap to and it no longer cares if they could originally take those slots.
  - Added a Leave Sex interaction.
    - Choose which Sims will leave and choose an animation the other Sims will play upon your Sim leaving.
    - If an animation is not available for the number of Sims left, then the sex will simply just end!
  - Reduced the finickiness of the is Ask For Sex interaction.
  - Sims may now interact with sex if they are not involved, if the sex involves a player, and regardless of whether the Manual NPC Sex Setting is on or not (The setting will soon be removed anyways).
  **Autonomy**
  - When starting sex autonomously, Sims will now only consider having sex at objects within their immediate vicinity (Can be adjusted in the settings).
  - When starting sex autonomously, Sims will now only consider Sims to have sex with that are within their immediate vicinity (Can be adjusted in the settings).
  - Sims will no longer attempt to join your sex from across the map. Only Sims on the same lot will try. If you are off the lot, only Sims who are also off the lot will join.
  - Autonomous Join sex no longer checks if the Autonomous Start sex setting is enabled. It only checks if autonomous join is enabled now.
  **Overlays**
  - The automatic Cum overlays will now only apply if an animation is a Climax animation.
  **CAS Parts**
  - CAS Parts now utilize Sim Type and Gender, they no longer consider Age and Species.
  **Settings**
  - Added a setting to disable overlays completely.
  - The setting regarding "allowing Female Sims to take Male slots" have been changed to "Allow Sims with a Vagina to take slots that require a Penis."
    - You must enable this setting in order for Female Sims to utilize Strap-ons.
  - The setting regarding "allowing Male Sims to take Female slots" have been changed to "Allow Sims with a Penis to take slots that require a Vagina."
  - The "Use vanilla gender" setting has been removed.
  - Added settings for adjusting the maximum distance between Sims and the maximum distance between a Sim and objects in order for a Sim to consider sex.
  - Removed the "Manual NPC Control" setting. You may control NPCs automatically now.
  - Known Quirks:
    - If a Sim is holding something, such as a bowl of yogurt, they will continue to hold that something when sex starts.
- DD Kinky
  - Gender Preferences will no longer be accounted for between Aggressors, if a Sim attempts to join an Assault as an Aggressor.
  - Relationship changes have been fixed between Aggressors, Non-Aggressors, Doms, and Subs.
  - Relationship changes should no longer apply twice.
- DD Pets
  - Pet Sims are now selected via the Start Sexy Time interaction, the same as Human Sims
  - The Ask Pet To Join and Start Sex With Pet interactions have been removed. Pets may now be selected from the Ask To Join and Start Sexy Time interactions.
  - Sims no longer require having the Zoophiliac trait in order to Manually start sex with pets. In this case, when sex is started and pets are involved, all Sims will receive the Zoophiliac trait (thus enabling autonomous sex with pets for them in the process).
    - When Sims are attempting to start autonomy, they will still require the Zoophiliac trait in order to autonomously have sex with pets.
  - Added Pet Occults for animations (Vampire, Alien, Mermaid, Witch, and Robot)
    - If you are wondering, these occults are available via Hybrids. They may not be fully functional, but they are sometimes given to pets when they are born a Hybrid.
- DD Milkfarm
  - Added Penisfeeding
    - Added a new tag for animations "PENISFEEDING"
    - Added new tags for animation actors "PENISFEEDING_MILK_RECEIVER" and "PENISFEEDING_MILK_GIVER
    - Penisfeeding will increase hunger for the Sims receiving the penis milk.
  - To start Breastfeeding and Penisfeeding, you now start them via the Start Sexy Time interaction

Version 1.73:
- DD General:
  - Overlays may now be removed within Animation Customization
  - Added the ability to disable 3d overlays in the settings.
  - DD will now check if a Sim is in WW sex before updating their outfit and will ignore updating it, if they are.
    - DD no longer cares about WW penis state because of this.
  - Fixed some issues when checking if a Sim has an outfit equipped or not.
  - Fixed some issues detecting whether a Sim is bottomless, topless, or shoeless.
  - Added the ability to apply/remove overlays to or from Sims manually (SHIFT+CLICK on Sim -> Devious Desires -> Modify Applied Overlays)
  - Added the ability to set specific clothing parts as REVEALING within the Devious Desires settings -> Show Outfit Information
    - This does not currently do anything specific right now, except persist your changes. I plan to allow things such as a Penis showing underneath a skirt or breasts popping out of an open shirt.
  - Fixed an issue where tags were not being loaded for animations and actors from DD tunings
  - Increase the number of tags shown when modifying tags in Animation Customization to 200 per page from 25.


- DD Pets:
  - When leashing a Sim, they will use their normal walk style. They will no longer do the goofy looking walk.
  - The Penis Knot trait will no longer be auto applied, because it was pointless to auto apply it to anything (Dogs are already considered to have a knot)
  - Pets will no longer unequip their clothing when their bits are equipped
  - New body parts
    - New pet penises and vaginas, Pets may now wear clothing while also wearing their penis.
    - New Cat Vagina
	- With these new body parts, the Pets bodies will no longer clip through clothing!
  - Pet penises and vaginas are now accessories instead of replacing the full body slot.
  
- DD MilkFarm:
  - Added a motherlode animation to DD Milk Farm to be used as the default. You will no longer NEED to download a separate animation for it to work! (You can if you want to though!)
- **DD now requires at least version 1.55 of S4CL**

Version 1.72:
- Fixed an obvious issue when trying to apply overlays.

Version 1.71:
- Fixed Sims whipping out their dicks at awkward times after they ask for WW sex, but before they get to the sex location.
- Fixed an issue when the Location Sample Size is a large value than the number of sex locations found during both manual sex and autonomous sex.
- Fix an error that occurs when the location sample size is large than the number of locations
- Reworked Overlays quite a bit. Also fixed them not properly sticking around.
- Overlays now support weights, Light, Medium, Heavy
- When a Sim has an overlay on them already, if another event tries to apply another overlay to the same spot, the weight will increase.
  - Sim A has a light cum layer on their face. Sim B Cums on the face of Sim A. Sim A now has a medium cum layer on their face.
- Added many new cum layers.
- The saved settings file now looks much nicer (at the cost of a little bit more space)
- **Devious Desires now requires at least version 1.54 of S4CL**

Version 1.70:
- When making animation customizations, your own customizations are now saved separately from the rest of the customization files. If you plan to upload your customizations
  - Make sure you rename `my_own_customizations.json` to something that IS NOT `main.json` or `combined.json`
- Added the ability to customize actor actions, will occur inside and is penetrating target
- Added the BOTH_BUTT_CHEEKS, LEFT_BUTT_CHEEK, RIGHT_BUTT_CHEEK Actor Animation tags.
- Fixed autonomy always choosing the same Sims and same sex locations! Fixed the randomness.
- When choosing a location for autonomy, if a Sim is on the lot, they will prefer locations on the lot, if they are off the lot, they will prefer locations off the lot.
- Added the ability to both add and modify Overlays for actions made to Sims in Animation Customizations.
- Added the ability to set the "Sex Role Preference" of your Sim to be either "NONE", "GIVER", or "RECEIVER".
  - This preference is now also used in sex, assuming the tags on the animation are set properly!
- Fixed milk farm tunings throwing an error for those without the Outdoor Retreat DLC (It was never meant to be a requirement anyways)
  - Cum and Milk Overlays are now properly applied and removed when Sims change equipment, take showers, or brush their teeth.
- Added custom penis milkers
- Added custom vagina and mouth Cum overlays.
- **Devious Desires now requires at least version 1.53 of S4CL**

Version 1.69:
- Added a GIVER and RECEIVER actor tag for future use in determining which slot a Sim should prefer to take first based on their preferred position (Giving or Receiving)
- Added the ability to tag Actors in Animations as GIVER and/or RECEIVER when customizing animations
- DD can now determine whether a Sim would be able to have sex if it attempted to start it autonomously with a Sim.
  - If another mod is preventing the DD sex interactions from queueing, DD will simply not even try to start sex with them in the first place.
- Penis state in Wicked Whims will be considered when updating the outfit of a Sim.
- Figured out and fixed the reason why so many animations were simply not being loaded or looked at.
- Showers and Bathtubs should now increase hygiene while having sex in them.
- **Devious Desires now requires at least version 1.52 of S4CL**
- Changed how animation customization files are loaded, the files are now loaded via a folder called "animation_customizations", putting multiple json files within there (with different names) will allow DD to load separate configurations for animations at a time. Keep in mind "main.json" will always overwrite anything else in that folder!
  - Changed the file structure a bit within "mod_data", I moved `mod_data/deviousdesires_animation_customizations.json` to `mod_data/animation_customizations/main.json`
  - When customizing animations and saving, your changes are now saved to "combined.json"
  - !!!!If you wish to keep your own personal customizations, please move your file AND rename it to something that IS NOT `main.json` or `combined.json`!!!!

Version 1.68:
- Custom Breast Milk and Penis Milk objects instead of using the Srsly Sims ones
  - They come in Vanilla, Chocolate, Banana, and Strawberry "flavors", randomly chosen while a Sim is being milked (This will be changed and it won't be random in the future!)
    - Your Sim can drink all of them
      - Breast and Penis Milk will increase hunger!
    - They can be sold for cash monies
  - New Chest icon in equipment selector
  - A few fixes
  - Fixed penis milking not properly ending
  - Fixed an error when attempting to auto apply the breast producer to pregnant Sims
- Added custom mobile breast milker thanks to the community!
- When equipping a breast milker, the necklace of a Sim is removed now.
- Fixed an issue where removing Overlays caused all outfits of every category to be replaced with the outfit in the first slot of each category.
- Fixed the Equipment interactions not working on Sims in some scenarios (Pregnant Sims, Sims doing Yoga, etc.)
- When a Sim gets naked or the outfit they are changing to has naked parts, their outfit will now be properly updated.
- Actually fixed the Penis not becoming hard, probably. I'm sure someone out there will find a way to break it.
- **Devious Desires now requires at least version 1.49 of S4CL!**
  - Some folder structure changes to work with the new version of S4CL
  - With the new S4CL changes (v1.48), please move the `The Sims 4/saves/deviousdesires` folder to `The Sims 4/Mods/mod_data/deviousdesires`

Version 1.67:
- Fixed the Penis not being hard during sex
- Fixed Lot Traits being checked incorrectly when calculating want levels
- Fixed Hybrid pregnancies not working for a few people
- Added the ability to disable specific animations via the Show Available Animations debug interaction.
- Absolutely prevented autonomy when features or autonomy are disabled for specific things (Assault, Normal Sex, Rough Sex)
- The Penis Knot trait will no longer be automatically added to Sims that don't actually have a Knot by default.
  - Unfortunately you will need to manually remove it from the Sims you don't want it on. (Because I can't distinguish whether DD auto added it or it was added manually)
- During an active milking, the milking apparatus, Sims outfit, and milk overlays will not be constantly modified. If your Sim changes outfits, the milker won't automatically remove their clothing again.
- A setting to disable automatic progression of animations. (Still some kinks, after a really long time the interaction just ends)
- Updated icons in various places in both the settings and the Equipment Selector
- The Body Selector is now the Equipment Selector
- Devious Desires no longer cares if Wicked Whims is running.
- String Tables reorganization and a couple identifier changes (Leash, Change Animation, A few settings, etc.)
- Cleaned up the settings so there are not so many menus and it looks somewhat nicer.
- Reduced the size of the mod
- Devious Desires now requires at least version 1.47 of S4CL

Version 1.66:
- General:
  - Solo Sex
  - Autonomy Fix
  - Risk Roll removal
  - New icons
  - New settings for allowing special NPCs, Sleeping Sims (Still testing), Ignoring Forbidden Buffs and Ignoring Forbidden Situations
- DD Kinky
  - Bad Neighborhood Lot trait
  - Bad Neighborhood buffs
  - Domination Skill
  - Submission Skill
- DD Pets
  - Penis Knot trait (and debug interactions)

Version 1.65:
- New Club actions (Normal Sex, Rough Sex, Assault) All of them include interactions with pets (If dd_pets is installed of course)
- New settings to limit Assault and Being Assaulted to the Rapist and Victim traits respectively.
- New settings to give the Rapist and Victim traits to random Sims.

Version 1.64:
- Split DD Pets, DD Kinky, and DD Milk Farm into their own package files.
- If one of the above packages is installed, it's features will be enabled automatically.
  - If you have already had Devious Desires installed in your Mods folder, you will need to manually enable the features yourself!
- Potentially fixed Overlays not properly unequipping during a Milking.

Version 1.63:
- Fixed an issue with the Add/Remove Milk Producer trait interactions that prevented them from appearing correctly when DD Milk Farm is enabled.

Version 1.62:
- DD reward traits (Pack Bitch, Milk Producer, etc.) are now properly removed or added based on whether a Feature is enabled or not. (No more restarts required)
- Removed the WW mouth cum layer being considered as a Mouth milk layer.
- Fixed the DD Milk Farm settings title
- Fixed the DD Pets settings title and description
- DD no longer cares if Sims have the WW Sex Persistence Buff
- The Milk Producer traits will now be applied on Sim spawn if the Sim matches the criteria for each (Male auto get Penis Milk Producer and Pregnant auto get Breast Milk Producer)
- The Breast Milk Producer Trait will now be auto applied to pregnant Sims both current ones and future ones
- Devious Desires now requires at least version 1.44 of S4CL

Version 1.61:
- Many Sims that were not supposed to appear when trying to start assault were appearing! (They didn't work even after being selected anyways)

Version 1.60:
- Milk Level now properly decreases instead of increasing while a Sim is milked
- Milk Levels will no longer change while the body location is being milked.
- Added debug trait interactiosn for adding and remove Breast Milk Producer and Penis Milk Producer
- Added an interaction to stop milking
- When Penis Milking, the penis becomes erect.
- Other minor errors fixed.

Version 1.59:
- Massively reduced the complexity of autonomy checks to prevent things breaking after single changes.
- Reduced the number of calls being made to check if a Sim is or isn't allowed to have sex, have rough sex, or assault.
- No longer check a number of things abuot Sims to prevent them from doing autonomous sex, assault, and rough sex.
  - Interactions
  - Motive Levels
  - Full Autonomy
- Sims no longer have to be within range to manually start or join sex with them.
- Added some checks for when Sims in an active animation interaction become None for whatever reason. (They basically become unloaded at some point)
- Devious Desires now requires at least version 1.43 of S4CL.

Version 1.58:
- Fixed an issue with assault autonomy resulting in -1000 when setting the allowance settings to disallow Male to be assaulted and disallow Female to assault.
- In order to keep your settings, within your The Sims 4/saves/deviousdesires folder, please rename "do_not_remove_deviousdesires_colonolnutty_id_123_guid_534.json" to "deviousdesires_main_id_123_guid_534.json" (Obviously my id and guid won't match yours!)
- In order to keep your animation customizations, within your The Sims 4/saves/deviousdesires folder, please rename "do_not_remove_deviousdesires_colonolnutty_animation_customizations.json" to "deviousdesires_animation_customizations.json".
- The default Animation Customizations file is now included with the Devious Desires archive, be careful not to overwrite any of your customizations with the default!
- Devious Desires now requires at least version 1.42 of S4CL

Version 1.57:
- General
  - Possessed Sims can now have be used for animations.
  - Devious Desires will no longer use the Wicked Whims default body parts as it's own body parts (It will use the Native body parts)
    - This change now means you must download a separate body to use with Devious Desires or download a body that replaces the vanilla body parts!
  - Settings
    - Toggle Normal Sex Autonomy
	- Replaced the two "Random Autonomy Cooldown Time Minimum" and Maximum settings with a single "Autonomous Sex Cooldown Time" setting.
	  - The default number of seconds was bumped from 90 seconds to 120 seconds (2 minutes between autonomy attempts)
    - Allow DD to run even while running WW sex. (Disable to prevent the "Is engaged in WW Sex" tooltip)
  - Added the ability to select Strap-on (Though the names provided by the Strap-on authors are terrible)
  - DD no longer uses the strap-on selected via WW.
  - Autonomy
    - Reduced the complexity of Autonomous Sex, Assault, and Rough Sex to increase the occurrence of them.
    - Random autonomy is no longer random, it is on a strict cooldown time now.
	- Assault, Rough Sex, and Normal Sex now run separately from each other. They can all be activated at the same time!
    - Changed random commands to autonomy commands
      - dd.testnormalrandom -> dd.testnormalautonomy
      - dd.testassaultrandom -> dd.testassaultautonomy
      - dd.testroughrandom -> dd.testroughautonomy
      - dd.triggernormalrandom -> dd.triggernormalautonomy
      - dd.triggerassaultrandom -> dd.triggerassaultautonomy
      - dd.triggerroughrandom -> dd.triggerroughautonomy
- Animation Customization
  - Animation Customization dialogs now go back to the page the player was on when navigating back through the dialogs
  - Updated the text of Aggressor/Non-Aggressor to show they add Dom/Sub too
  - Changed the Aggressive, Rough, and Breastfeeding options for Animations into Toggle buttons with checkboxes.
- DD Milkfarm
  - Added the basics of milking.
    - Sim has milk level, Sim gets milked, Sim gets milk apparatus, Milk Bottle appears in inventory. (Requires Srsly Sims)
  - Added separate interactions for penis and breast milking
    - Added support for Pet milking. (Though there are no current animations yet.)
    - Ask For Milk will now look at and modify breast milk levels
  - Added traits for producing breast milk and penis milk
    - The penis milk trait does do anything just yet!
- DD Kinky
  - Assault
    - Settings
      - Toggle whether pets respect the Zoophiliac trait or not when attempting an Assault. (DD Pets integration)
	  - Autonomous Assault Cooldown
	  - Toggle Assault Autonomy
  - Rough Sex
    - Settings
	  - Autonomous Rough Sex Cooldown
	  - Toggle Rough Sex Autonomy
- Devious Desires now requires at least version 1.41 of S4CL
- Devious Desires no longer requires Wicked Whims

Version 1.56:
- Climax animations now show in the Show Available Animations and Customize Animations dialog
- Added a Customize Current Animation debug interaction that is available when SHIFT+CLICK on a Sim involved in Sex.

Version 1.55:
- Fixed an issue where allowance settings for assault for not properly being checked for only the assaulting Sims.
- Updated the messaging from "have sex with" to also be "assault" and "have rough sex with" to indicate a difference.

Version 1.54:
- Changed the True Family want level modifier, while the incest cheat is enabled from -100 to -50
- Fixed an issue where filtering simply wasn't working for animations.
- Fixed an issue where Breastfeeding interactions were not properly being flagged as breastfeeding. (Thus leading to the code treating it as Normal Sex)
- Updated the title of the failed to start assault notification to no longer say Breastfeeding.
- Expanded the information provided when doing the test random assault/normal sex/rough sex commands to show Want Levels and failed willingness reasons.

Version 1.53:
- Fixed issues when locating rough sex interactions
- Improved performance when locating objects to have sex at.
- Lowered the default want thresholod for Assault to 200.0
- Lowered the default want to have rough sex as dom/sub to 200.0

Version 1.52:
- Fixed Normal Sex, Assault, Rough Sex, and Breastfeeding interactions not filtering for the correct animations when started by clicking on a Sim.

Version 1.51:
- Settings should now only save on game save.
- Devious Desires now requires at least version 1.38 of S4CL!

Version 1.50:
- Prevent the Ask For Milk (Pet) interaction being visible while DD Milk Farm is disabled.

Version 1.49:
- Ask For Rough Sex now checks for consent before being able to choose it.
- Fixed a few issues with animation tag changes
- Devious Desires now requires at least version 1.37 of S4CL.

Version 1.48:
- Enable Human x Human manual sex, NPC sex, and autonomy.

Version 1.47:
- Added Animation Customization. Changes also persist, so share the animation customizations with your buddies and the rest of the community! Expect more customization options in the future.
  - Customize animation tags, actor tags, actor gender, and actor preferred gender.
  - Set animations as aggressive, breastfeeding, or rough
  - Set actors as aggressors, non-aggressors, breastfeeding givers, breastfeeding receivers
- Update S4CL to at least version 1.36 with this update!

Version 1.46:
- Pets should no longer appear in the Manual NPC Assault dialog unless DD Pets is enabled.

Version 1.45:
- Added a Manual NPC Assault interaction.

Version 1.44:
- Fix a minor error with the Show Actor Info interaction when a Sim is not engaged in sex.

Version 1.43:
- Prevent changing animations/locations during a breastfeeding or a knotting
- Added two new animations by Laser and lucobiano
- Sims should no longer remove their clothing to become erect if they are not already bottomless. (They should be erect when they next take their clothes off though!)
- Fixed overlays not being removed properly when doing cleaning interactions.
- Tears will now apply to non aggressor Sims during an assault (or an aggressive animation)
- Milk will now auto apply during a breastfeeding (or a breastfeeding animation) to both nipple and mouth

Version 1.42:
- Fixed animations not progressing correctly
- Fixed animations not properly ending after awhile (I plan to add a setting to make this customizable, but it is currently set to 500 seconds)
- Fixed the knotting stuff being applied in situations where knotting doesn't make sense. I know of a few animations that still cause it, but that's because they were written incorrectly.
- Breastfeeding will now properly end when the animation finishes.
- Fixed the preferred animation gender on the motherlode breastfeeding animation.
- Fixed the interaction to directly ask a Sim for milk (rather than clicking on the ground or something)
- Devious Desires settings now saves its settings to "saves/deviousdesires/do_not_remove_...".
- Devious Desires now requires at least version 1.34 of S4CL

Version 1.41:
- Fix overlays not properly being applied.

Version 1.40:
- Fixed Sims equipping a Robot penis when undressing during an animation.
- When animations are assigning Sims to actor slots, the Sims will now be sorted in a way where Sims with a penis are assigned before Sims that would use a Strap-on.

Version 1.39:
- All but entirely reduced the 2-3 second delay when updating the outfit of Sims by changing how CAS Parts are cached to miniscule times!
- Added a Tears overlay
- The default breastfeeding animation utilizes the new Tears overlay
- Added some reasonings to appear in the want level debug dialog for want levels being -1000.0
- Overlays will no longer be updated on zone update when a Sim is involved in an animation.
- Removed threading usages from many places until I can figure out how to properly do threading
  - If Enable Call Threading setting is enabled, load times in theory should be reduced

Version 1.38:
- Added Rapist and Victim Traits
  - These factor only into the Want To Assault Levels
  - Add/Remove them the same way Zoophiliac is added/removed.
- Added an Add and a Remove pie category under Traits for better organization
- The Sim To Pet Romance track is now factored into the Want To Have Sex, Want To Have Rough Sex as Dom/Sub and Want To Assault Levels

Version 1.37:
- Added Romance relationship track for Human Sim x Pet Sims.
- Added Hug and Kiss romantic interactions available for Zoophiliacs only.
  - The Hug and Kiss romantic interactions for Small Pets (Dog and Cat) only appear while the pets are being held. (I'll figure out how to do it without picking them up later)
- Added statistics to track when a Sim is Topless, Bottomless, and Shoeless
- Fixed settings asking for input, with the initial value being blank.
- Fixed some settings not having the proper type, thus causing things to blow up.
- Fixed an issue where Sims would not become erect during sex sometimes.
- Devious Desires now requires at least version 1.33 of S4CL!

Version 1.36:
- Added a setting to enable call threading Global Settings -> General Settings -> Enable Call Threading.
  - When enabled, the performance enhancements made to animations will become enabled, however it also increases the risk of things breaking/the game crashing, beware!
- Readded knotting.

Version 1.35:
- Redo how settings and other data are saved to reduce save bloating (This resets the settings to default and all features to disabled!)
- Possibly fix the crashes or freezes some people are experiencing before and after animations.
- Added an error message when an animation is loaded with invalid actors.

Version 1.34:
- Increased the performance and speed when starting and transitioning animations.
- Prevent starting and transitioning of animations from "pausing" everything else in the game.
- When starting, transitioning, and ending animations, Outfit updates (Undressing/Dressing) are run in parallel to everything else, so there is a slight delay before the Outfit of Sims will be updated.
- When triggering random sex, assault, and rough sex as well as when triggering a join to those, the code no longer "pauses" everything else.
- Fixed animations not progressing after they have finished playing.
- Fixed an issue when checking for a hidden pregnancy on Sims that have become unloaded.
- Fixed some issues where DD animations were not showing their display names properly.

Version 1.33:
- Renamed Get Dressed to Equip All
- Added a setting to modify equipment of NPCs
- Cleaned up the dressing interactions to share a common class

Version 1.32:
- Improved the performance when playing an animation a little bit (Less time where the game is paused)
- Fixed a NoneType error within `get_appearance_modifiers_gen`
- Fixed an issue that occurs when starting a Milk animation.
- Add a check to prevent DD interrupting WW sex.
- Fixed an issue when undressing Sims during an animation.

Version 1.31:
- Added undress interactions:
  - All
  - Hat
  - Gloves
  - Shoes
  - Tights

Version 1.30:
- Fixed hybrid pregnancies not properly being detected.
- Fixed the Start Sex With Pet interaction not properly becoming disabled for non-zoophiliacs.

Version 1.29:
- Cleaned up loading of package data to handle errors better
- Create a new way to specify events within animation tunings, also allow multiple types of events to be applied.
- Fix robots and mermaids/mermen not properly working with Devious Desires stuff (Nudity and animations)
- Disabled the Unequip bottom and top interactions for Robots.
- Added a way to send cease and desist letters (Not literal letters) to Wicked Whims while Sims are engaged in DD sex.
- Allowed some interactions to be available (Like MCC, S4CL, etc.) during DD sex.

Version 1.28:
- Add a setting to disable relationship changes for Assault.

Version 1.27:
- Updated the icon for the Milk Farm Pie Category to a Cow Hide
- Added Enable/Disable settings for Assault (Age, Gender, Species)
- Added Interactions to Allow/Disallow assault for specific Sims. SHIFT+CLICK (Sim) -> Devious Desires -> Traits
- Added settings to Enable/Disable Assault and Rough Sex.
- Reorganized the DD Kinky menu to split Assault and Rough Sex settings

Version 1.26:
- Renamed some of the elements within tuning files to make more sense.
- Fixed some tuning elements not having the correct names.
- Change how overlays are loaded via tunings
- Update package snippets with new tuning format
- Added new overlay body locations:
  - NIPPLE_BOTH, NIPPLE_LEFT, NIPPLE_RIGHT, MOUTH, BUTT_LEFT, BUTT_RIGHT, PENIS
- Added new overlay types, MILK, CUM, TEARS, BLUSH
- The Lactation overlay (Tattoo slot) by sstormy is now applied to the breasts after Breastfeeding to the Breasts of the Sim being breastfed from.
- Reworked how cas parts are loaded.
- Change cum layer tuning to overlay tuning
- The Hunger meter now goes up for the receiver while breast feeding
- Sims can no longer join a Sim that is breastfeeding autonomously
- Fixed Sims not properly being assigned when the settings "Allow Female To Take Male Slots" or "Allow Male To Take Female Slots" are enabled.
- Human Sims with a penis will now properly dress up after Sex.
- Updated the notifications when starting Breastfeeding and when starting Sex to be more generic.

Version 1.25:
- Fixed locations for sex not being found in many cases when trying to start autonomous normal sex, assault, and rough sex.
- Added a single animation for breastfeeding, but it is still unfinished.
- Fixed the "close to labor" message being shown on Sims that are not pregnant.

Version 1.24:
- Fixed Sims deciding to not wear pants when loading into a Lot (Whether first time or via travelling).
- Added Milk Farm settings (Though there aren't any specific settings just yet.
- Added Ask For Milk interaction, but it does not fully function just yet.

Version 1.23:
- Reduced the massive load time increase while DD is installed
- Fixed an error thrown when a Sim declines sex.
- Cleaned up nudity functions so in theory it should be impossible for invisible parts to come about, but who really knows.
- Added notifications for successful and failed assault attempts
- Moved notification sex for success/failed to the string tables
- Fixed relationship tracks accidentally being added for combinations that don't have the relationship tracks
  - Such as romance for pet x pet and pet x human or friendship for pet x pet

Version 1.22:
- Fixed Sims having invisible body parts when their first Everyday outfit is a Full Body outfit.
- Fixed the outfit of a Sim changing to their Everyday outfit when unequipping clothing.
- Sims will now auto equip their clothing after sex.
- Devious Desires now requires at least version 1.32 of The Sims 4 Community Library

Version 1.21:
- Added debuffs and a relationship loss after Assault.
- Relationship levels now tank after a failed Assault Attempt.
- Fixed an issue when retrieving Submissive Sims in an animation.

Version 1.20:
- Add a chance to fail Assault Attempts
- Change the Win Assault Attempt Threshold into a flat percentage chance instead.
- Added more detailed error messaging when CAS Parts fail to load.

Version 1.19:
- Adjusted some of the want level factors
- Fixed objects not having their animations be found when searching for a location to have sex, rough sex, and assault.
- Fixed the No Sims Available message when clicking on locations.
- Fixed the Accept Sex Threshold showing the wrong default setting.

Version 1.18:
- Added Want Levels For Rough Sex As Dom/Sub and Assault.
  - Added Threshold settings for the Want Level to Have Rough Sex as Dom/Sub and the Want Level to Assault other Sims.
- Raised the Want Level thresholds to be much higher in scale (Going from around 1.5-3.0 to like 200-400)
  - This allows for more flexibility.
- Updated the Want To Have Sex Want Level to be much higher by default.
- Added a Win Attempt Threshold to settings (Not used yet, but available)
- Removed usages of all Traits from Wicked Whims. (If you don't want incest, disable the incest Cheat!)
- Move the Accept Sex threshold to the global settings
- Fixed Pets not being able to initiate sex, rough sex, or assault.
- Disable Knotting Buffs entirely (At least until I rework it)
- Fixed potential issue where pregnancy buffs were not being registered to Sims properly resulting in some pregnancies not being detected as Hybrids.
- Remove superfluous errors when loading animations
- Load other props of animations if at least some of the props are available
- Updated the Show Want Levels debug interaction to show more details and to make it more user friendly
- Remove the random math from want level calculations, now it is simply adding various numbers together, no multiplying, dividing, etc. (1 + 1) vs (1 + (1 * 0.1) + 0.5/3/2)

Version 1.17:
- Handle when an animation specifies to not remove any clothing, when it makes more sense to remove the clothing item.
- Fixed Sims not becoming nude during sex in some cases.
- Fixed the Penis of Sims not properly updating in some cases.
- Added interactions
  - Unequip Top
  - Unequip Bottom
  - Get Dressed
  - Set Erect (Will remove a Sims bottom clothing when used)
  - Set Flaccid (Will remove a Sims bottom clothing when used)
- Updated icons for interactions and the Body Selector to look much cooler.
- Prevent Rough Sex and Assault happening autonomously when DD Kinky is disabled.
- Prevent Pets having sex autonomously when DD Pets is disabled.
- Animation Tuning
  - Added new Naked Types
    - HANDS
    - FEET
  - Removed animation_force_nude_hands and animation_force_nude_feet and opted to use NakedTypes instead.
  - Added actor_remove_body_types to actors of an animation, which allows for more control over which body parts are undressed/unequipped during sex.
  - Added more animation categories: KISSING, MILKING, BREASTFEEDING
- CAS Parts
  - Added a Body Selector interaction for Human Sims
  - Fixed a few issues when handling CAS Part Icons
  - Changed the type of part_display_icon in CAS Part snippets to be of type int.
- Show Actor Info now displays the name of the animation and name of the author if a Sim is engaged in sex.
- DD no longer uses CAS Parts selected via the Wicked Whims body selector.


Version 1.16:
- Move the auto undress settings into their own menu under nudity settings

Version 1.15:
- Added new settings to auto undress various body parts
  - Gloves
  - Socks
  - Shoes
  - Leggings
- Fixed an issue where sex would continue advancing even when the game was paused.
- Fixed an issue where the knotting buff would not be removed properly in some cases.
- If an actor in an animation specifies it is available for both male and female, but specifies the preferred gender as female, the animation will only be available for Sims considered to be Female and the preferred gender will be ignored.

Version 1.14:
- Fixed an error when Sims try to ask for Rough Sex. (This led to Sims auto declining)

Version 1.13:
- Fixed the Start Sex With Pet dialog showing Human Sims instead of Pets like it should doh!

Version 1.12:
- Added Assault (Start/Join) interactions and autonomy
  - Added a way to invite Sims to be Submissive in an Assault interaction. (Consent will be checked for Sims joining as Sub of course!)
- Fixed Rough Sex autonomy not properly tagging Sims when it started.
- Fixed Rough Sex autonomy not properly working for Human x Human.
- Fixed Cats not getting a penis
- Fixed a case where the Animation Gender Based On Genitals setting was actually doing the opposite.
- Fixed some cases where Wicked Whims animations were not properly being loaded by DD.

Version 1.11:
- Add a setting to enable Non-Aggressive/Non-Rough animations to be used for Rough Sex.

Version 1.10:
- Added Autonomy For Starting and Joining Rough Sex

Version 1.9:
- Allow Strap-on in animations is now completely ignored.
- If preferred gender is set to Male, a strap-on will be equipped automatically.
  - This may lead to many incorrect animations equipping strap-ons when they don't need them, but that just means the animation itself is incorrect!
- Fixed an issue where Pet Sims were declining normal sex 100% of the time (without always accept on)
- Fixed strap-ons not being properly equipped when needed during an animation.

Version 1.8:
- Removed all usages of Wicked Whims settings
- Added new Global Settings
  - Cheats
    - Teleport Sims To Sex Location
  - Gender Settings
    - Animation Gender Based On Genitals
    - Allow Male Sims To Take Female Gender Slots
    - Allow Female Sims To Take Male Gender Slots
    - Allow Sims To Take Any Gender Slot

Version 1.7:
- Added Start and Join Rough Sex interactions (Human x Human, Human x Pet, and Pet x Pet)
  - Rough Sex explicitly looks for Aggressive animations at the moment. I plan to integrate the toggle to enable all animations in the future.
- The Zoophiliac trait can now be added during sex (But not removed)

Version 1.6:
- Fix an error with settings not having a default value set for them.

Version 1.5:
- Fixed an error that is thrown when testing whether the Ask For Sex Human interaction should appear.
- Add Give, Take Away, Ask To Give, and Ask To Take Away consent interactions.

Version 1.4:
- Reorganized the settings dialog
- Random Autonomy Maximum and Minimum Cooldown max values changed to 9999.0 from 100.0
- Random Autonomy Maximum Cooldown min value changed to 1.0 from 0.0
- Changed the verbage of many things within the settings.
- Added Global Settings, Feature Settings and DD Pet Settings (Will only appear when the DD Pet Feature is enabled.
- Split the Global settings from DD Pet settings.

Version 1.3:
- Fixed not being able to save settings
- Added an Enable Kinky Features setting

Version 1.2:
- The Enable Pet Features setting wasn't properly showing the correct state it was set to. This is fixed.
- Removed the cancel button from the Restart Required Confirmation dialog.

Version 1.1:
- Added an Enable Pet Features setting enable/disable Pets
- DD Pets is now disabled by default
- Fixed the String Tables have a ton of duplicate entries.

Version 1.0:
- Initial Release